module     P2B_ddx_ssx_model
   ! Model parameters for the model: smdiag
   use P2B_ddx_ssx_config, only: ki, &
   & samurai_scalar, samurai_verbosity, samurai_test, &
   & renormalisation, reduction_interoperation
   implicit none

   private :: ki
   private :: samurai_scalar, samurai_verbosity, samurai_test
   private :: renormalisation, reduction_interoperation

   real(ki), parameter :: sqrt2 = &
      &1.414213562373095048801688724209698078&
      &5696718753769480731766797379_ki
   
   real(ki) :: alpha =        0.007297352537600_ki
   real(ki), parameter :: gs =        1.000000000000000_ki
   real(ki), parameter :: mB =        0.000000000000000_ki
   real(ki) :: mBMS =        4.200000000000000_ki
   real(ki), parameter :: mC =        0.000000000000000_ki
   real(ki), parameter :: mD =        0.000000000000000_ki
   real(ki), parameter :: me =        0.000000000000000_ki
   real(ki) :: mH =      114.400000000000006_ki
   real(ki), parameter :: mmu =        0.000000000000000_ki
   real(ki), parameter :: mS =        0.000000000000000_ki
   real(ki) :: mT =      171.199999999999989_ki
   real(ki) :: mtau =        1.776840000000000_ki
   real(ki), parameter :: mU =        0.000000000000000_ki
   real(ki) :: mW =       80.376000000000005_ki
   real(ki) :: mZ =       91.187600000000003_ki
   real(ki) :: NC =        3.000000000000000_ki
   real(ki) :: Nf =        5.000000000000000_ki
   real(ki) :: Nfgen =        5.000000000000000_ki
   real(ki) :: wB =        0.000000000000000_ki
   real(ki) :: wchi =        0.000000000000000_ki
   real(ki) :: wghWm =        0.000000000000000_ki
   real(ki) :: wghWp =        0.000000000000000_ki
   real(ki) :: wghZ =        0.000000000000000_ki
   real(ki) :: wH =        0.000000000000000_ki
   real(ki) :: wphi =        0.000000000000000_ki
   real(ki), parameter :: wT =        0.000000000000000_ki
   real(ki) :: wtau =        0.000000000000000_ki
   real(ki) :: wW =        2.124000000000000_ki
   real(ki) :: wZ =        2.495200000000000_ki
   real(ki) :: gUa
   real(ki) :: gWWZZ
   real(ki) :: gBa
   real(ki) :: gtauv
   real(ki) :: gWWZ
   real(ki) :: gBv
   real(ki) :: gUv
   real(ki) :: gHZZ
   real(ki) :: gtaua
   real(ki) :: gW
   real(ki) :: gHHH
   real(ki) :: gntauv
   real(ki) :: gAPP
   real(ki) :: gntaua
   real(ki) :: gZZXX
   real(ki) :: gCa
   real(ki) :: gev
   real(ki) :: gWZPH
   real(ki) :: gHC
   real(ki) :: gGWH
   real(ki) :: gea
   real(ki) :: gAZPP
   real(ki) :: gCv
   complex(ki) :: gGWX
   real(ki) :: gPWZ
   real(ki) :: gZZHH
   real(ki) :: gHHPP
   real(ki) :: gZZPP
   real(ki) :: gGZWP
   real(ki) :: gHXX
   real(ki) :: gWWPP
   real(ki) :: gWAPH
   real(ki) :: gDv
   real(ki) :: gGZH
   real(ki) :: gDa
   complex(ki) :: gWAPX
   real(ki) :: gHWW
   real(ki) :: gWWXX
   real(ki) :: gTa
   real(ki) :: gTv
   real(ki) :: gPtau
   real(ki) :: gHPP
   real(ki) :: gWWAZ
   real(ki) :: gWWAA
   real(ki) :: gAAPP
   real(ki) :: gHtau
   real(ki) :: gZ
   real(ki) :: gXmu
   real(ki) :: gHHHH
   real(ki) :: Nfrat
   real(ki) :: cw
   real(ki) :: gGWZP
   real(ki) :: gnmua
   real(ki) :: NA
   real(ki) :: gSv
   real(ki) :: gnev
   real(ki) :: gnmuv
   complex(ki) :: gZXH
   real(ki) :: gnea
   real(ki) :: gHmu
   real(ki) :: gPPPP
   real(ki) :: gXtau
   real(ki) :: gWWHH
   real(ki) :: gWWWW
   real(ki) :: gXT
   real(ki) :: gXU
   complex(ki) :: gWZPX
   real(ki) :: gHHXX
   real(ki) :: gXD
   real(ki) :: gmuv
   real(ki) :: gXB
   real(ki) :: gXC
   real(ki) :: gSa
   real(ki) :: gHe
   real(ki) :: gmua
   real(ki) :: gPB
   real(ki) :: gXS
   real(ki) :: gHT
   real(ki) :: gHU
   real(ki) :: gHS
   real(ki) :: gPWA
   real(ki) :: gHD
   real(ki) :: gHB
   real(ki) :: gPmu
   real(ki) :: gZPP
   real(ki) :: gXe
   real(ki) :: gPe
   real(ki) :: gXXXX
   real(ki) :: e
   real(ki) :: gPD
   real(ki) :: sw
   real(ki) :: gWPH
   real(ki) :: gPC
   real(ki) :: gXXPP
   real(ki) :: gPT
   real(ki) :: gPU
   complex(ki) :: gWPX
   real(ki) :: gPS

   integer, parameter, private :: line_length = 80
   integer, parameter, private :: name_length = max(5,24)
   character(len=name_length), dimension(20) :: names = (/& 
      & "alpha", &
      & "mBMS ", &
      & "mH   ", &
      & "mT   ", &
      & "mtau ", &
      & "mW   ", &
      & "mZ   ", &
      & "NC   ", &
      & "Nf   ", &
      & "Nfgen", &
      & "wB   ", &
      & "wchi ", &
      & "wghWm", &
      & "wghWp", &
      & "wghZ ", &
      & "wH   ", &
      & "wphi ", &
      & "wtau ", &
      & "wW   ", &
      & "wZ   "/)
   character(len=1), dimension(3) :: cc = (/'#', '!', ';'/)

   private :: digit, parsereal, names, cc

contains

   function     digit(ch, lnr) result(d)
      implicit none
      character(len=1), intent(in) :: ch
      integer, intent(in) :: lnr
      integer :: d
      d = -1
      select case(ch)
         case('0')
            d = 0
         case('1')
            d = 1
         case('2')
            d = 2
         case('3')
            d = 3
         case('4')
            d = 4
         case('5')
            d = 5
         case('6')
            d = 6
         case('7')
            d = 7
         case('8')
            d = 8
         case('9')
            d = 9
         case default
            write(*,'(A21,1x,I5)') 'invalid digit in line', lnr
         end select
   end function digit

   function     parsereal(str, ierr, lnr) result(num)
      implicit none
      character(len=*), intent(in) :: str
      integer, intent(out) :: ierr
      integer, intent(in) :: lnr
      integer, dimension(0:3,0:4), parameter :: DFA = &
      & reshape( (/1,  1,  2, -1,   & ! state = 0
      &            1, -1,  2,  3,   & ! state = 1
      &            2, -1, -1,  3,   & ! state = 2
      &            4,  4, -1, -1,   & ! state = 3
      &            4, -1, -1, -1/), (/4, 5/))
      real(ki) :: num
      integer :: i, expo, ofs, state, cclass, d, s1, s2
      num = 0.0_ki
      expo = 0
      state = 0
      ofs = 0
      s1 = 1
      s2 = 1
      d = -1
      cclass = -1
      do i=1,len(str)
         select case(str(i:i))
         case('_', '''', ' ')
            cycle
         case('+', '-')
            cclass = 1
         case('.')
            cclass = 2
         case('E', 'e')
            cclass = 3
         case default
            cclass = 0
            d = digit(str(i:i), lnr)
            if (d .eq. -1) then
               ierr = 1
               return
            end if
         end select
         if (cclass .eq. 0) then
            select case(state)
            case(0, 1)
               num = 10.0_ki * num + d
            case(2)
               num = 10.0_ki * num + d
               ofs = ofs - 1
            case(4)
               expo = 10 * expo + d
            end select
         elseif ((cclass .eq. 1) .and. (str(i:i) .eq. '-')) then
            if (state .eq. 0) then
               s1 = -1
            else
               s2 = -1
            endif
         end if
         ! Advance in the DFA
         state = DFA(cclass, state)
         if (state < 0) then
            write(*,'(A21,1x,A1,1x,A7,I5)') 'invalid position for', &
            & str(i:i), 'in line', lnr
            ierr = 1
            return
         end if
      end do
      num = s1 * num * 10.0_ki**(ofs + s2 * expo)
      ierr = 0
   end function parsereal

   subroutine     parseline(line,stat,line_number)
      implicit none
      character(len=*), intent(in) :: line
      integer, intent(out) :: stat
      integer, intent(in), optional :: line_number

      character(len=line_length) :: rvalue, ivalue, value
      character(len=name_length) :: name
      real(ki) :: re, im
      integer :: idx, lnr, nidx, ierr

      if(present(line_number)) then
         lnr = line_number
      else
         lnr = 0
      end if

      idx = scan(line, '=', .false.)
      if (idx .eq. 0) then
         if(present(line_number)) then
            write(*,'(A13,1x,I5)') 'error at line', line_number
         else
            write(*,'(A18)') 'error in parseline'
         end if
         stat = 1
         return
      end if
      name = line(1:idx-1)
      value = line(idx+1:len(line))
      idx = scan(value, ',', .false.)

      if (name .eq. "renormalisation") then
         re = parsereal(value, ierr, lnr)
         if (ierr .ne. 0) then
            stat = 1
            return
         end if
         renormalisation = int(re)
      elseif (name .eq. "reduction_interoperation") then
         re = parsereal(value, ierr, lnr)
         if (ierr .ne. 0) then
            stat = 1
            return
         end if
         reduction_interoperation = int(re)
      elseif (name .eq. "samurai_scalar") then
         re = parsereal(value, ierr, lnr)
         if (ierr .ne. 0) then
            stat = 1
            return
         end if
         samurai_scalar = int(re)
      elseif (name .eq. "samurai_verbosity") then
         re = parsereal(value, ierr, lnr)
         if (ierr .ne. 0) then
            stat = 1
            return
         end if
         samurai_verbosity = int(re)
      elseif (name .eq. "samurai_test") then
         re = parsereal(value, ierr, lnr)
         if (ierr .ne. 0) then
            stat = 1
            return
         end if
         samurai_test = int(re)
      elseif (any(names .eq. name)) then
         do nidx=1,size(names)
            if (names(nidx) .eq. name) exit
         end do
         if (idx .gt. 0) then
            rvalue = value(1:idx-1)
            ivalue = value(idx+1:len(value))
            re = parsereal(rvalue, ierr, lnr)
            if (ierr .ne. 0) then
               stat = 1
               return
            end if
            im = parsereal(ivalue, ierr, lnr)
            if (ierr .ne. 0) then
               stat = 1
               return
            end if
         else
            re = parsereal(value, ierr, lnr)
            if (ierr .ne. 0) then
               stat = 1
               return
            end if
            im = 0.0_ki
         end if
         select case (nidx)
         case(1)
            alpha = re
         case(2)
            mBMS = re
         case(3)
            mH = re
         case(4)
            mT = re
         case(5)
            mtau = re
         case(6)
            mW = re
         case(7)
            mZ = re
         case(8)
            NC = re
         case(9)
            Nf = re
         case(10)
            Nfgen = re
         case(11)
            wB = re
         case(12)
            wchi = re
         case(13)
            wghWm = re
         case(14)
            wghWp = re
         case(15)
            wghZ = re
         case(16)
            wH = re
         case(17)
            wphi = re
         case(18)
            wtau = re
         case(19)
            wW = re
         case(20)
            wZ = re
         end select
      else
         write(*,'(A20,1x,A20)') 'Unrecognized option:', name
         stat = 1
         return
      end if
      stat = 0
   end subroutine parseline

   subroutine     parse(aunit)
      implicit none
      integer, intent(in) :: aunit
      character(len=line_length) :: line
      integer :: ios, lnr
      lnr = 0
      loop1: do
         read(unit=aunit,fmt='(A80)',iostat=ios) line
         if(ios .ne. 0) exit
         lnr = lnr + 1
         line = adjustl(line)
         if (line .eq. '') cycle loop1
         if (any(cc .eq. line(1:1))) cycle loop1

         call parseline(line,ios,lnr)
         if(ios .ne. 0) then
            write(*,'(A44,I2,A1)'), &
            & 'Error while reading parameter file in parse(', aunit, ')'
         end if
      end do loop1
   end subroutine parse
!---#[ SLHA READER:
   subroutine     read_slha(ch, ierr)
      implicit none
      integer, intent(in) :: ch
      integer, intent(out), optional :: ierr

      integer :: lnr, i, l, ofs, ios
      character(len=255) :: line

      integer :: block

      ofs = iachar('A') - iachar('a')

      lnr = 0
      loop1: do
         read(unit=ch,fmt='(A80)',iostat=ios) line
         if(ios .ne. 0) exit
         lnr = lnr + 1

         i = scan(line, '#', .false.)
         if (i .eq. 0) then
            l = len_trim(line)
         else
            l = i - 1
         end if

         if (l .eq. 0) cycle loop1

         ucase: do i = 1, l
            if (line(i:i) >= 'a' .and. line(i:i) <= 'z') then
               line(i:i) = achar(iachar(line(i:i))+ofs)
            end if
         end do ucase

         if (line(1:1) .eq. 'B') then
            if (line(1:5) .eq. 'BLOCK') then
               line = adjustl(line(6:l))
               do i=1,l
                 if (line(i:i) <= ' ') exit
               end do
               l = i
               if ("MASSES" .eq. line(1:l)) then
                  block = 0
               else
                  block = -1
               end if
            else
               write(*,'(A37,I5)') "Illegal statement in SLHA file, line ", lnr
               if (present(ierr)) ierr = 1
               return
            end if
         else
            ! read a parameter line
            select case(block)
            case(0)
               call read_slha_block_masses(line(1:l), i)
               if (i .ne. 0) then
                  if (present(ierr)) ierr = 1
                  write(*,'(A44,I5)') &
                  & "Unrecognized line format in SLHA file, line ", lnr
                  return
               end if
            case default
               cycle loop1
            end select
         end if
      end do loop1
      if (present(ierr)) ierr = 0
   end subroutine read_slha

   subroutine read_slha_block_masses(line, ierr)
      implicit none
      character(len=*), intent(in) :: line
      integer, intent(out), optional :: ierr
      integer :: idx1,ioerr
      real(ki) :: value

      read(line,*,iostat=ioerr) idx1, value
      if (ioerr .ne. 0) then
         if (present(ierr)) ierr = 1
         return
      end if
      select case(idx1)
      case(24)
         mW = value
      case(25)
         mH = value
      case(23)
         mZ = value
      case(6)
         mT = value
      case(15)
         mtau = value
      end select
      if (present(ierr)) ierr = 0
   end subroutine read_slha_block_masses
!---#] SLHA READER:
!---#[ subroutine init_functions:
   subroutine     init_functions()
      implicit none
      complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
      real(ki), parameter :: pi = 3.14159265358979323846264&
     &3383279502884197169399375105820974944592307816406286209_ki
      complex(ki) :: reg1
      real(ki) :: reg2
      real(ki) :: reg3
      real(ki) :: reg4
      real(ki) :: reg5
      real(ki) :: reg6
      real(ki) :: reg7
      real(ki) :: reg8
      real(ki) :: reg9
      real(ki) :: reg10
      real(ki) :: reg11
      real(ki) :: reg12
      real(ki) :: reg13
      real(ki) :: reg14
      real(ki) :: reg15
      real(ki) :: reg16
      real(ki) :: reg17
      real(ki) :: reg18
      real(ki) :: reg19
      real(ki) :: reg20
      gAPP = (-1.0_ki)
      gWWAA = (-1.0_ki)
      gAAPP = (2.0_ki)
      Nfrat = (Nf/Nfgen)
      cw = (mW/mZ)
      gWZPH = (-1.0_ki/2.0_ki)/cw
      NA = (NC*NC-(1.0_ki))
      gWZPX = (-1.0_ki/2.0_ki)/cw*i_
      gPWA = -(mW)
      e = (sqrt(((4.0_ki)*alpha*pi)))
      reg2 = mW*mW
      sw = (sqrt(((1.0_ki)-reg2/(mZ*mZ))))
      reg3 = cw*cw
      reg4 = sw*sw
      gWWZZ = (-1.0_ki)*reg3/reg4
      reg5 = cw/sw
      gWWZ = -(reg5)
      reg6 = mW/(reg3*sw)
      gHZZ = reg6
      gW = (1.0_ki)/(sqrt2*sw)
      reg7 = mH*mH
      reg2 = reg7/(reg2*sw)
      gHHH = (-3.0_ki/2.0_ki)*reg2
      reg8 = cw*sw
      gZ = (1.0_ki)/reg8
      reg9 = (1.0_ki/4.0_ki)*gZ
      gUa = reg9
      gBa = -(reg9)
      reg10 = ((1.0_ki/4.0_ki)-reg4)*gZ
      gtauv = -(reg10)
      reg11 = ((1.0_ki/4.0_ki)-(1.0_ki/3.0_ki)*reg4)*gZ
      gBv = -(reg11)
      reg12 = ((1.0_ki/4.0_ki)-(2.0_ki/3.0_ki)*reg4)*gZ
      gUv = reg12
      gtaua = -(reg9)
      gntaua = reg9
      reg13 = reg8*reg8
      reg14 = (1.0_ki/2.0_ki)/reg13
      gZZXX = reg14
      gCa = reg9
      reg15 = mW*sw
      gPWZ = (-1.0_ki)*reg15/cw
      reg16 = mW*sqrt2*sw
      gPmu = (mmu/reg16)
      reg17 = mW/sw
      gGWH = (-1.0_ki/2.0_ki)*reg17
      gea = -(reg9)
      reg18 = -(reg4+reg3)
      gAZPP = (reg18/reg8)
      gCv = reg12
      reg19 = (1.0_ki/2.0_ki)/reg15*mmu
      gXmu = reg19
      gGWX = (-1.0_ki/2.0_ki)*i_*mW/sw
      gZZHH = reg14
      reg7 = reg7/(reg15*reg15)
      reg14 = (3.0_ki/4.0_ki)*reg7
      gHHHH = -(reg14)
      reg3 = reg3-reg4
      gZZPP = (-1.0_ki)*reg3*reg3/reg13
      gGZWP = ((1.0_ki/2.0_ki)/reg8*mW)
      reg2 = (1.0_ki/2.0_ki)*reg2
      gHXX = -(reg2)
      reg13 = (1.0_ki/2.0_ki)/reg4
      gWWPP = reg13
      reg20 = (1.0_ki/2.0_ki)/sw
      gWAPH = -(reg20)
      gDv = -(reg11)
      gGZH = (-1.0_ki/2.0_ki)*reg6
      gDa = -(reg9)
      reg1 = (1.0_ki/2.0_ki)*i_/sw
      gWAPX = -(reg1)
      gHWW = reg17
      gWWXX = reg13
      gTa = reg9
      gTv = reg12
      gPtau = (mtau/reg16)
      gHPP = -(reg2)
      gWWAZ = reg5
      reg2 = (1.0_ki/2.0_ki)/reg15*mtau
      gHtau = -(reg2)
      gntauv = reg9
      reg5 = (1.0_ki/4.0_ki)*reg7
      gHHPP = -(reg5)
      gGWZP = ((1.0_ki/2.0_ki)*reg18/reg8*mW)
      gnmua = reg9
      reg6 = (1.0_ki/2.0_ki)/reg15*mC
      gXC = -(reg6)
      gnev = reg9
      gnmuv = reg9
      gZXH = (-1.0_ki/2.0_ki)/reg8*i_
      gnea = reg9
      gHmu = -(reg19)
      gPPPP = (-1.0_ki/2.0_ki)*reg7
      gXtau = reg2
      gWWHH = reg13
      gWWWW = (1.0_ki)/reg4
      reg2 = (1.0_ki/2.0_ki)/reg15*mT
      gXT = -(reg2)
      reg4 = (1.0_ki/2.0_ki)/reg15*mU
      gXU = -(reg4)
      gHHXX = -(reg5)
      reg7 = (1.0_ki/2.0_ki)/reg15*mD
      gXD = reg7
      gmuv = -(reg10)
      reg12 = (1.0_ki/2.0_ki)/reg15*mBMS
      gXB = reg12
      gSv = -(reg11)
      gSa = -(reg9)
      reg11 = (1.0_ki/2.0_ki)/reg15*me
      gHe = -(reg11)
      gmua = -(reg9)
      gWPH = -(reg20)
      reg9 = (1.0_ki/2.0_ki)/reg15*mS
      gXS = reg9
      gev = -(reg10)
      gHT = -(reg2)
      gHU = -(reg4)
      gHS = -(reg9)
      gHD = -(reg7)
      gHB = -(reg12)
      gHC = -(reg6)
      gZPP = ((1.0_ki/2.0_ki)*reg3/reg8)
      gXe = reg11
      gPe = (me/reg16)
      gXXXX = -(reg14)
      gPD = (mD/reg16)
      gPB = (mBMS/reg16)
      gPC = (mC/reg16)
      gXXPP = -(reg5)
      gPT = (mT/reg16)
      gPU = (mU/reg16)
      gWPX = -(reg1)
      gPS = (mS/reg16)
   end subroutine init_functions
!---#] subroutine init_functions:
!---#[ utility functions for model initialization:
   pure function ifpos(x0, x1, x2)
      implicit none
      real(ki), intent(in) :: x0, x1, x2
      real(ki) :: ifpos

      if (x0 > 0.0_ki) then
         ifpos = x1
      else
         ifpos = x2
      endif
   end  function ifpos

   pure function sort4(m1, m2, m3, m4, n)
      implicit none
      real(ki), intent(in) :: m1, m2, m3, m4
      integer, intent(in) :: n
      real(ki) :: sort4

      real(ki), dimension(4) :: m
      logical :: f
      integer :: i
      real(ki) :: tmp

      m(1) = m1
      m(2) = m2
      m(3) = m3
      m(4) = m4

      ! Bubble Sort
      do
         f = .false.

         do i=1,3
            if (abs(m(i)) .gt. abs(m(i+1))) then
               tmp = m(i)
               m(i) = m(i+1)
               m(i+1) = tmp
               f = .true.
            end if
         end do

         if (.not. f) exit
      end do

      sort4 = m(n)
   end  function sort4
!---#] utility functions for model initialization:
end module P2B_ddx_ssx_model
