module     P2B_ddx_ssx_d20h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P2B_ddx_
   ! ssx/helicity0/d20h0l1.f90
   ! generator: haggies (1.1)
   use P2B_ddx_ssx_config, only: ki
   use P2B_ddx_ssx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P2B_ddx_ssx_groups, only: &
!           & sign => diagram20_sign, shift => diagram20_shift
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd20h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d20
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d20 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t16 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t17 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t18 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t19 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t3*abb20n5
      t25 = t3*abb20n6
      d20 = (t1*abb20n14+t10*t25+t2*abb20n32+t24*t6+t24*t8+t25*t9+t3*abb20n33+t4&
      &*abb20n45+t1*t18*abb20n36+t10*t19*abb20n37+t10*t7*abb20n17+t11*t12*abb20n&
      &8+t11*t14*abb20n8+t11*t19*abb20n39+t11*t3*abb20n7+t11*t7*abb20n18+t12*t13&
      &*abb20n20+t12*t15*abb20n21+t12*t16*abb20n22+t12*t17*abb20n23+t12*t18*abb2&
      &0n31+t12*t20*abb20n41+t12*t21*abb20n42+t12*t22*abb20n43+t12*t23*abb20n44+&
      &t12*t4*abb20n51+t12*t5*abb20n9+t13*t14*abb20n20+t13*t18*abb20n25+t14*t15*&
      &abb20n21+t14*t16*abb20n22+t14*t17*abb20n23+t14*t18*abb20n31+t14*t20*abb20&
      &n41+t14*t21*abb20n42+t14*t22*abb20n43+t14*t23*abb20n44+t14*t4*abb20n51+t1&
      &4*t5*abb20n9+t15*t18*abb20n24+t16*t18*abb20n27+t17*t18*abb20n26+t18*t2*ab&
      &b20n36+t18*t20*abb20n46+t18*t21*abb20n47+t18*t22*abb20n48+t18*t23*abb20n4&
      &9+t18*t3*abb20n35+t18*t4*abb20n52+t19*t5*abb20n40+t19*t6*abb20n38+t19*t8*&
      &abb20n38+t19*t9*abb20n37+t3*t4*abb20n50+t3*t5*abb20n10+t3*abb20n11*(Q(1)*&
      &spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))+t3*abb20n&
      &12*(Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4))+&
      &t3*abb20n13*(Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spva&
      &k7k3(4))+t3*abb20n15*(Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-&
      &Q(4)*spvak8k3(4))+t3*abb20n28*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spv&
      &ak4k5(3)-Q(4)*spvak4k5(4))+t3*abb20n29*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)&
      &-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4))+t3*abb20n30*(Q(1)*spvak4k7(1)-Q(2)*sp&
      &vak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t3*abb20n34*(Q(1)*spvak4k8(1&
      &)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t5*t7*abb20n19+t6*t&
      &7*abb20n16+t7*t8*abb20n16+t7*t9*abb20n17+t10*t18*t4*abb20n53+t11*t18*t4*a&
      &bb20n55+t18*t4*t5*abb20n56+t18*t4*t6*abb20n54+t18*t4*t8*abb20n54+t18*t4*t&
      &9*abb20n53)
      numerator = cmplx(real(d20, ki), aimag(d20), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd20h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d20
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d20 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t16 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t17 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t18 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t19 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t3*abb20n5
      t25 = t3*abb20n6
      d20 = (t1*abb20n14+t10*t25+t2*abb20n32+t24*t6+t24*t8+t25*t9+t3*abb20n33+t4&
      &*abb20n45+t1*t18*abb20n36+t10*t19*abb20n37+t10*t7*abb20n17+t11*t12*abb20n&
      &8+t11*t14*abb20n8+t11*t19*abb20n39+t11*t3*abb20n7+t11*t7*abb20n18+t12*t13&
      &*abb20n20+t12*t15*abb20n21+t12*t16*abb20n22+t12*t17*abb20n23+t12*t18*abb2&
      &0n31+t12*t20*abb20n41+t12*t21*abb20n42+t12*t22*abb20n43+t12*t23*abb20n44+&
      &t12*t4*abb20n51+t12*t5*abb20n9+t13*t14*abb20n20+t13*t18*abb20n25+t14*t15*&
      &abb20n21+t14*t16*abb20n22+t14*t17*abb20n23+t14*t18*abb20n31+t14*t20*abb20&
      &n41+t14*t21*abb20n42+t14*t22*abb20n43+t14*t23*abb20n44+t14*t4*abb20n51+t1&
      &4*t5*abb20n9+t15*t18*abb20n24+t16*t18*abb20n27+t17*t18*abb20n26+t18*t2*ab&
      &b20n36+t18*t20*abb20n46+t18*t21*abb20n47+t18*t22*abb20n48+t18*t23*abb20n4&
      &9+t18*t3*abb20n35+t18*t4*abb20n52+t19*t5*abb20n40+t19*t6*abb20n38+t19*t8*&
      &abb20n38+t19*t9*abb20n37+t3*t4*abb20n50+t3*t5*abb20n10+t3*abb20n11*(Q(1)*&
      &spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))+t3*abb20n&
      &12*(Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4))+&
      &t3*abb20n13*(Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spva&
      &k7k3(4))+t3*abb20n15*(Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-&
      &Q(4)*spvak8k3(4))+t3*abb20n28*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spv&
      &ak4k5(3)-Q(4)*spvak4k5(4))+t3*abb20n29*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)&
      &-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4))+t3*abb20n30*(Q(1)*spvak4k7(1)-Q(2)*sp&
      &vak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t3*abb20n34*(Q(1)*spvak4k8(1&
      &)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t5*t7*abb20n19+t6*t&
      &7*abb20n16+t7*t8*abb20n16+t7*t9*abb20n17+t10*t18*t4*abb20n53+t11*t18*t4*a&
      &bb20n55+t18*t4*t5*abb20n56+t18*t4*t6*abb20n54+t18*t4*t8*abb20n54+t18*t4*t&
      &9*abb20n53)

      numerator = cmplx(real(d20, ki), aimag(d20), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P2B_ddx_ssx_d20h0l1
