module     P2B_ddx_ssx_d32h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P2B_ddx_
   ! ssx/helicity0/d32h0l1.f90
   ! generator: haggies (1.1)
   use P2B_ddx_ssx_config, only: ki
   use P2B_ddx_ssx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P2B_ddx_ssx_groups, only: &
!           & sign => diagram32_sign, shift => diagram32_shift
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd32h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d32
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d32 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = t1*abb32n11
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t1*abb32n12
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t14 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t15 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t16 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t17 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t18 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t19 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t20 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t21 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t22 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t25 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d32 = (t1*abb32n10+t1*abb32n52+t1*abb32n8+t10*t9+t2*abb32n30+t3*abb32n51+t&
      &4*abb32n62+t4*abb32n9+t5*t6+t6*t7+t8*t9+t1*t11*abb32n13+t1*t14*abb32n16+t&
      &1*t15*abb32n18+t1*t16*abb32n29+t1*t17*abb32n32+t1*t23*abb32n48+t1*t24*abb&
      &32n53+t1*t4*abb32n20+t1*abb32n27*(Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*&
      &spvak6k3(3)-Q(4)*spvak6k3(4))+t1*abb32n31*(Q(1)*spvak8k3(1)-Q(2)*spvak8k3&
      &(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4))+t1*abb32n46*(Q(1)*spvak4k5(1)-Q(2)&
      &*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t1*abb32n49*(Q(1)*spvak4k&
      &7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t10*t18*abb32n34&
      &+t10*t25*abb32n54+t11*t12*abb32n14+t11*t13*abb32n14+t11*t18*abb32n36+t11*&
      &t25*abb32n56+t12*t14*abb32n15+t12*t15*abb32n17+t12*t16*abb32n28+t12*t17*a&
      &bb32n33+t12*t19*abb32n38+t12*t20*abb32n39+t12*t21*abb32n40+t12*t22*abb32n&
      &41+t12*t23*abb32n47+t12*t24*abb32n50+t12*t26*abb32n58+t12*t27*abb32n59+t1&
      &2*t28*abb32n60+t12*t29*abb32n61+t12*t4*abb32n21+t13*t14*abb32n15+t13*t15*&
      &abb32n17+t13*t16*abb32n28+t13*t17*abb32n33+t13*t19*abb32n38+t13*t20*abb32&
      &n39+t13*t21*abb32n40+t13*t22*abb32n41+t13*t23*abb32n47+t13*t24*abb32n50+t&
      &13*t26*abb32n58+t13*t27*abb32n59+t13*t28*abb32n60+t13*t29*abb32n61+t13*t4&
      &*abb32n21+t14*t18*abb32n37+t14*t25*abb32n57+t15*t19*abb32n43+t15*t2*abb32&
      &n19+t15*t20*abb32n42+t15*t21*abb32n45+t15*t22*abb32n44+t15*t26*abb32n63+t&
      &15*t27*abb32n64+t15*t28*abb32n65+t15*t29*abb32n66+t15*t3*abb32n19+t15*t4*&
      &abb32n22+t18*t5*abb32n35+t18*t7*abb32n35+t18*t8*abb32n34+t25*t5*abb32n55+&
      &t25*t7*abb32n55+t25*t8*abb32n54+t10*t15*t4*abb32n23+t11*t15*t4*abb32n25+t&
      &14*t15*t4*abb32n26+t15*t4*t5*abb32n24+t15*t4*t7*abb32n24+t15*t4*t8*abb32n&
      &23)
      numerator = cmplx(real(d32, ki), aimag(d32), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd32h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d32
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d32 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = t1*abb32n11
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t1*abb32n12
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t14 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t15 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t16 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t17 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t18 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t19 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t20 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t21 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t22 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t25 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d32 = (t1*abb32n10+t1*abb32n52+t1*abb32n8+t10*t9+t2*abb32n30+t3*abb32n51+t&
      &4*abb32n62+t4*abb32n9+t5*t6+t6*t7+t8*t9+t1*t11*abb32n13+t1*t14*abb32n16+t&
      &1*t15*abb32n18+t1*t16*abb32n29+t1*t17*abb32n32+t1*t23*abb32n48+t1*t24*abb&
      &32n53+t1*t4*abb32n20+t1*abb32n27*(Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*&
      &spvak6k3(3)-Q(4)*spvak6k3(4))+t1*abb32n31*(Q(1)*spvak8k3(1)-Q(2)*spvak8k3&
      &(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4))+t1*abb32n46*(Q(1)*spvak4k5(1)-Q(2)&
      &*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t1*abb32n49*(Q(1)*spvak4k&
      &7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t10*t18*abb32n34&
      &+t10*t25*abb32n54+t11*t12*abb32n14+t11*t13*abb32n14+t11*t18*abb32n36+t11*&
      &t25*abb32n56+t12*t14*abb32n15+t12*t15*abb32n17+t12*t16*abb32n28+t12*t17*a&
      &bb32n33+t12*t19*abb32n38+t12*t20*abb32n39+t12*t21*abb32n40+t12*t22*abb32n&
      &41+t12*t23*abb32n47+t12*t24*abb32n50+t12*t26*abb32n58+t12*t27*abb32n59+t1&
      &2*t28*abb32n60+t12*t29*abb32n61+t12*t4*abb32n21+t13*t14*abb32n15+t13*t15*&
      &abb32n17+t13*t16*abb32n28+t13*t17*abb32n33+t13*t19*abb32n38+t13*t20*abb32&
      &n39+t13*t21*abb32n40+t13*t22*abb32n41+t13*t23*abb32n47+t13*t24*abb32n50+t&
      &13*t26*abb32n58+t13*t27*abb32n59+t13*t28*abb32n60+t13*t29*abb32n61+t13*t4&
      &*abb32n21+t14*t18*abb32n37+t14*t25*abb32n57+t15*t19*abb32n43+t15*t2*abb32&
      &n19+t15*t20*abb32n42+t15*t21*abb32n45+t15*t22*abb32n44+t15*t26*abb32n63+t&
      &15*t27*abb32n64+t15*t28*abb32n65+t15*t29*abb32n66+t15*t3*abb32n19+t15*t4*&
      &abb32n22+t18*t5*abb32n35+t18*t7*abb32n35+t18*t8*abb32n34+t25*t5*abb32n55+&
      &t25*t7*abb32n55+t25*t8*abb32n54+t10*t15*t4*abb32n23+t11*t15*t4*abb32n25+t&
      &14*t15*t4*abb32n26+t15*t4*t5*abb32n24+t15*t4*t7*abb32n24+t15*t4*t8*abb32n&
      &23)

      numerator = cmplx(real(d32, ki), aimag(d32), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P2B_ddx_ssx_d32h0l1
