module     P2B_ddx_ssx_d2h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P2B_ddx_
   ! ssx/helicity1/d2h1l1.f90
   ! generator: haggies (1.1)
   use P2B_ddx_ssx_config, only: ki
   use P2B_ddx_ssx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P2B_ddx_ssx_groups, only: &
!           & sign => diagram2_sign, shift => diagram2_shift
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd2h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d2
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d2 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t14 = t1*abb2n35
      t15 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t16 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      d2 = (t1*abb2n22+t1*t1*abb2n34+t14*t2+t14*t3+t2*abb2n23+t3*abb2n23+t4*abb2&
      &n33+t5*abb2n38+t6*abb2n4+t7*abb2n5+t8*abb2n5+t9*abb2n6+t1*t10*abb2n30+t1*&
      &t11*abb2n11+t1*t12*abb2n12+t1*t13*abb2n16+t1*t4*abb2n15+t1*t5*abb2n45+t1*&
      &t6*abb2n20+t1*t7*abb2n17+t1*t9*abb2n24+t10*t12*abb2n2+t10*t13*abb2n9+t10*&
      &t2*abb2n31+t10*t3*abb2n31+t10*t4*abb2n36+t10*t5*abb2n40+t10*t7*abb2n10+t2&
      &*t5*abb2n44+t2*t6*abb2n21+t2*t9*abb2n25+t3*t5*abb2n44+t3*t6*abb2n21+t3*t9&
      &*abb2n25+t4*t5*abb2n47+t4*t6*abb2n3+t4*t9*abb2n7+t5*t6*abb2n43+t5*t7*abb2&
      &n46+t5*t8*abb2n46+t5*t9*abb2n48+t1*t10*t5*abb2n56+t1*t10*t6*abb2n28+t1*t1&
      &5*t6*abb2n19+t1*t16*t6*abb2n26+t1*t4*t5*abb2n52+t1*t4*t6*abb2n13+t1*t5*t9&
      &*abb2n51+t1*t5*abb2n53*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3&
      &)-Q(4)*spvak3k8(4))+t10*t12*t5*abb2n37+t10*t13*t5*abb2n42+t10*t2*t6*abb2n&
      &29+t10*t3*t6*abb2n29+t10*t4*t5*abb2n54+t10*t5*t6*abb2n39+t10*t5*t7*abb2n5&
      &5+t11*t4*t6*abb2n8+t11*t5*t6*abb2n41+t15*t2*t6*abb2n18+t15*t3*t6*abb2n18+&
      &t16*t2*t6*abb2n27+t16*t3*t6*abb2n27+t2*t4*t6*abb2n14+t2*t5*t6*abb2n50+t3*&
      &t4*t6*abb2n14+t3*t5*t6*abb2n50+t4*t5*t9*abb2n49+t5*t6*abb2n32*(Q(1)*spvak&
      &3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t10*t4*t5*t6*a&
      &bb2n57)
      numerator = cmplx(real(d2, ki), aimag(d2), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd2h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d2
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d2 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t14 = t1*abb2n35
      t15 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t16 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      d2 = (t1*abb2n22+t1*t1*abb2n34+t14*t2+t14*t3+t2*abb2n23+t3*abb2n23+t4*abb2&
      &n33+t5*abb2n38+t6*abb2n4+t7*abb2n5+t8*abb2n5+t9*abb2n6+t1*t10*abb2n30+t1*&
      &t11*abb2n11+t1*t12*abb2n12+t1*t13*abb2n16+t1*t4*abb2n15+t1*t5*abb2n45+t1*&
      &t6*abb2n20+t1*t7*abb2n17+t1*t9*abb2n24+t10*t12*abb2n2+t10*t13*abb2n9+t10*&
      &t2*abb2n31+t10*t3*abb2n31+t10*t4*abb2n36+t10*t5*abb2n40+t10*t7*abb2n10+t2&
      &*t5*abb2n44+t2*t6*abb2n21+t2*t9*abb2n25+t3*t5*abb2n44+t3*t6*abb2n21+t3*t9&
      &*abb2n25+t4*t5*abb2n47+t4*t6*abb2n3+t4*t9*abb2n7+t5*t6*abb2n43+t5*t7*abb2&
      &n46+t5*t8*abb2n46+t5*t9*abb2n48+t1*t10*t5*abb2n56+t1*t10*t6*abb2n28+t1*t1&
      &5*t6*abb2n19+t1*t16*t6*abb2n26+t1*t4*t5*abb2n52+t1*t4*t6*abb2n13+t1*t5*t9&
      &*abb2n51+t1*t5*abb2n53*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3&
      &)-Q(4)*spvak3k8(4))+t10*t12*t5*abb2n37+t10*t13*t5*abb2n42+t10*t2*t6*abb2n&
      &29+t10*t3*t6*abb2n29+t10*t4*t5*abb2n54+t10*t5*t6*abb2n39+t10*t5*t7*abb2n5&
      &5+t11*t4*t6*abb2n8+t11*t5*t6*abb2n41+t15*t2*t6*abb2n18+t15*t3*t6*abb2n18+&
      &t16*t2*t6*abb2n27+t16*t3*t6*abb2n27+t2*t4*t6*abb2n14+t2*t5*t6*abb2n50+t3*&
      &t4*t6*abb2n14+t3*t5*t6*abb2n50+t4*t5*t9*abb2n49+t5*t6*abb2n32*(Q(1)*spvak&
      &3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t10*t4*t5*t6*a&
      &bb2n57)

      numerator = cmplx(real(d2, ki), aimag(d2), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P2B_ddx_ssx_d2h1l1
