module     P2B_ddx_ssx_d17h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P2B_ddx_
   ! ssx/helicity3/d17h3l1.f90
   ! generator: haggies (1.1)
   use P2B_ddx_ssx_config, only: ki
   use P2B_ddx_ssx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P2B_ddx_ssx_groups, only: &
!           & sign => diagram17_sign, shift => diagram17_shift
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd17h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d17
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d17 = 0.0_ki
      t1 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t2 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t10 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = t3*abb17n16
      t13 = t3*abb17n17
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t16 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t17 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t18 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t19 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t20 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t21 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t22 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t23 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t24 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t25 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d17 = (t1*abb17n10+t12*t8+t12*t9+t13*t5+t13*t7+t2*abb17n15+t3*abb17n36+t4*&
      &abb17n5+t1*t24*abb17n51+t10*t14*abb17n19+t10*t15*abb17n19+t10*t25*abb17n8&
      &+t10*t3*abb17n18+t10*t6*abb17n13+t11*t14*abb17n20+t11*t15*abb17n20+t11*t2&
      &5*abb17n9+t11*t3*abb17n21+t11*t6*abb17n14+t14*t16*abb17n23+t14*t17*abb17n&
      &25+t14*t18*abb17n26+t14*t19*abb17n28+t14*t2*abb17n40+t14*t20*abb17n31+t14&
      &*t21*abb17n33+t14*t22*abb17n34+t14*t23*abb17n37+t14*t24*abb17n49+t15*t16*&
      &abb17n23+t15*t17*abb17n25+t15*t18*abb17n26+t15*t19*abb17n28+t15*t2*abb17n&
      &40+t15*t20*abb17n31+t15*t21*abb17n33+t15*t22*abb17n34+t15*t23*abb17n37+t1&
      &5*t24*abb17n49+t16*t24*abb17n45+t16*t3*abb17n22+t17*t24*abb17n46+t17*t3*a&
      &bb17n24+t18*t24*abb17n47+t18*t3*abb17n27+t19*t24*abb17n48+t19*t3*abb17n29&
      &+t2*t24*abb17n52+t2*t3*abb17n39+t20*t24*abb17n42+t20*t3*abb17n30+t21*t24*&
      &abb17n41+t21*t3*abb17n32+t22*t24*abb17n44+t22*t3*abb17n35+t23*t24*abb17n4&
      &3+t23*t3*abb17n38+t24*t3*abb17n50+t24*t4*abb17n51+t25*t5*abb17n7+t25*t7*a&
      &bb17n7+t25*t8*abb17n6+t25*t9*abb17n6+t5*t6*abb17n11+t6*t7*abb17n11+t6*t8*&
      &abb17n12+t6*t9*abb17n12+t10*t2*t24*abb17n55+t11*t2*t24*abb17n56+t2*t24*t5&
      &*abb17n53+t2*t24*t7*abb17n53+t2*t24*t8*abb17n54+t2*t24*t9*abb17n54)
      numerator = cmplx(real(d17, ki), aimag(d17), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd17h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d17
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d17 = 0.0_ki
      t1 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t2 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t10 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = t3*abb17n16
      t13 = t3*abb17n17
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t16 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t17 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t18 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t19 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t20 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t21 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t22 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t23 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t24 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t25 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d17 = (t1*abb17n10+t12*t8+t12*t9+t13*t5+t13*t7+t2*abb17n15+t3*abb17n36+t4*&
      &abb17n5+t1*t24*abb17n51+t10*t14*abb17n19+t10*t15*abb17n19+t10*t25*abb17n8&
      &+t10*t3*abb17n18+t10*t6*abb17n13+t11*t14*abb17n20+t11*t15*abb17n20+t11*t2&
      &5*abb17n9+t11*t3*abb17n21+t11*t6*abb17n14+t14*t16*abb17n23+t14*t17*abb17n&
      &25+t14*t18*abb17n26+t14*t19*abb17n28+t14*t2*abb17n40+t14*t20*abb17n31+t14&
      &*t21*abb17n33+t14*t22*abb17n34+t14*t23*abb17n37+t14*t24*abb17n49+t15*t16*&
      &abb17n23+t15*t17*abb17n25+t15*t18*abb17n26+t15*t19*abb17n28+t15*t2*abb17n&
      &40+t15*t20*abb17n31+t15*t21*abb17n33+t15*t22*abb17n34+t15*t23*abb17n37+t1&
      &5*t24*abb17n49+t16*t24*abb17n45+t16*t3*abb17n22+t17*t24*abb17n46+t17*t3*a&
      &bb17n24+t18*t24*abb17n47+t18*t3*abb17n27+t19*t24*abb17n48+t19*t3*abb17n29&
      &+t2*t24*abb17n52+t2*t3*abb17n39+t20*t24*abb17n42+t20*t3*abb17n30+t21*t24*&
      &abb17n41+t21*t3*abb17n32+t22*t24*abb17n44+t22*t3*abb17n35+t23*t24*abb17n4&
      &3+t23*t3*abb17n38+t24*t3*abb17n50+t24*t4*abb17n51+t25*t5*abb17n7+t25*t7*a&
      &bb17n7+t25*t8*abb17n6+t25*t9*abb17n6+t5*t6*abb17n11+t6*t7*abb17n11+t6*t8*&
      &abb17n12+t6*t9*abb17n12+t10*t2*t24*abb17n55+t11*t2*t24*abb17n56+t2*t24*t5&
      &*abb17n53+t2*t24*t7*abb17n53+t2*t24*t8*abb17n54+t2*t24*t9*abb17n54)

      numerator = cmplx(real(d17, ki), aimag(d17), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P2B_ddx_ssx_d17h3l1
