module     P2B_ddx_ssx_d25h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P2B_ddx_
   ! ssx/helicity3/d25h3l1.f90
   ! generator: haggies (1.1)
   use P2B_ddx_ssx_config, only: ki
   use P2B_ddx_ssx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P2B_ddx_ssx_groups, only: &
!           & sign => diagram25_sign, shift => diagram25_shift
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd25h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d25 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb25n13
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb25n14
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t17 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t18 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t19 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t20 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t21 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t24 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t25 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t26 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t27 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t28 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t29 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d25 = (t1*abb25n10+t1*abb25n12+t1*abb25n56+t10*t11+t10*t9+t2*abb25n27+t3*a&
      &bb25n32+t4*abb25n37+t4*abb25n9+t6*t7+t7*t8+t1*t13*abb25n16+t1*t15*abb25n1&
      &7+t1*t18*abb25n39+t1*t19*abb25n41+t1*t20*abb25n42+t1*t21*abb25n44+t1*t22*&
      &abb25n46+t1*t23*abb25n49+t1*t24*abb25n50+t1*t25*abb25n52+t1*t26*abb25n55+&
      &t1*t27*abb25n58+t1*t28*abb25n64+t1*t29*abb25n65+t1*t4*abb25n20+t1*t5*abb2&
      &5n21+t11*t16*abb25n29+t11*t17*abb25n34+t12*t13*abb25n15+t12*t15*abb25n18+&
      &t12*t18*abb25n38+t12*t19*abb25n40+t12*t20*abb25n43+t12*t21*abb25n45+t12*t&
      &22*abb25n47+t12*t23*abb25n48+t12*t24*abb25n51+t12*t25*abb25n53+t12*t26*ab&
      &b25n54+t12*t27*abb25n57+t12*t28*abb25n63+t12*t29*abb25n66+t12*t4*abb25n19&
      &+t12*t5*abb25n22+t13*t14*abb25n15+t13*t16*abb25n30+t13*t17*abb25n35+t14*t&
      &15*abb25n18+t14*t18*abb25n38+t14*t19*abb25n40+t14*t20*abb25n43+t14*t21*ab&
      &b25n45+t14*t22*abb25n47+t14*t23*abb25n48+t14*t24*abb25n51+t14*t25*abb25n5&
      &3+t14*t26*abb25n54+t14*t27*abb25n57+t14*t28*abb25n63+t14*t29*abb25n66+t14&
      &*t4*abb25n19+t14*t5*abb25n22+t15*t16*abb25n31+t15*t17*abb25n36+t16*t6*abb&
      &25n28+t16*t8*abb25n28+t16*t9*abb25n29+t17*t6*abb25n33+t17*t8*abb25n33+t17&
      &*t9*abb25n34+t18*t5*abb25n67+t19*t5*abb25n68+t2*t5*abb25n71+t20*t5*abb25n&
      &69+t21*t5*abb25n70+t24*t5*abb25n60+t25*t5*abb25n59+t26*t5*abb25n62+t27*t5&
      &*abb25n61+t3*t5*abb25n72+t4*t5*abb25n11+t4*t5*abb25n73+t11*t4*t5*abb25n23&
      &+t13*t4*t5*abb25n25+t15*t4*t5*abb25n26+t4*t5*t6*abb25n24+t4*t5*t8*abb25n2&
      &4+t4*t5*t9*abb25n23)
      numerator = cmplx(real(d25, ki), aimag(d25), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd25h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d25 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb25n13
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb25n14
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t17 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t18 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t19 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t20 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t21 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t24 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t25 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t26 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t27 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t28 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t29 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d25 = (t1*abb25n10+t1*abb25n12+t1*abb25n56+t10*t11+t10*t9+t2*abb25n27+t3*a&
      &bb25n32+t4*abb25n37+t4*abb25n9+t6*t7+t7*t8+t1*t13*abb25n16+t1*t15*abb25n1&
      &7+t1*t18*abb25n39+t1*t19*abb25n41+t1*t20*abb25n42+t1*t21*abb25n44+t1*t22*&
      &abb25n46+t1*t23*abb25n49+t1*t24*abb25n50+t1*t25*abb25n52+t1*t26*abb25n55+&
      &t1*t27*abb25n58+t1*t28*abb25n64+t1*t29*abb25n65+t1*t4*abb25n20+t1*t5*abb2&
      &5n21+t11*t16*abb25n29+t11*t17*abb25n34+t12*t13*abb25n15+t12*t15*abb25n18+&
      &t12*t18*abb25n38+t12*t19*abb25n40+t12*t20*abb25n43+t12*t21*abb25n45+t12*t&
      &22*abb25n47+t12*t23*abb25n48+t12*t24*abb25n51+t12*t25*abb25n53+t12*t26*ab&
      &b25n54+t12*t27*abb25n57+t12*t28*abb25n63+t12*t29*abb25n66+t12*t4*abb25n19&
      &+t12*t5*abb25n22+t13*t14*abb25n15+t13*t16*abb25n30+t13*t17*abb25n35+t14*t&
      &15*abb25n18+t14*t18*abb25n38+t14*t19*abb25n40+t14*t20*abb25n43+t14*t21*ab&
      &b25n45+t14*t22*abb25n47+t14*t23*abb25n48+t14*t24*abb25n51+t14*t25*abb25n5&
      &3+t14*t26*abb25n54+t14*t27*abb25n57+t14*t28*abb25n63+t14*t29*abb25n66+t14&
      &*t4*abb25n19+t14*t5*abb25n22+t15*t16*abb25n31+t15*t17*abb25n36+t16*t6*abb&
      &25n28+t16*t8*abb25n28+t16*t9*abb25n29+t17*t6*abb25n33+t17*t8*abb25n33+t17&
      &*t9*abb25n34+t18*t5*abb25n67+t19*t5*abb25n68+t2*t5*abb25n71+t20*t5*abb25n&
      &69+t21*t5*abb25n70+t24*t5*abb25n60+t25*t5*abb25n59+t26*t5*abb25n62+t27*t5&
      &*abb25n61+t3*t5*abb25n72+t4*t5*abb25n11+t4*t5*abb25n73+t11*t4*t5*abb25n23&
      &+t13*t4*t5*abb25n25+t15*t4*t5*abb25n26+t4*t5*t6*abb25n24+t4*t5*t8*abb25n2&
      &4+t4*t5*t9*abb25n23)

      numerator = cmplx(real(d25, ki), aimag(d25), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P2B_ddx_ssx_d25h3l1
