module     P2B_ddx_ssx_d30h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P2B_ddx_
   ! ssx/helicity3/d30h3l1.f90
   ! generator: haggies (1.1)
   use P2B_ddx_ssx_config, only: ki
   use P2B_ddx_ssx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P2B_ddx_ssx_groups, only: &
!           & sign => diagram30_sign, shift => diagram30_shift
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd30h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d30
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d30 = 0.0_ki
      t1 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = t2*abb30n12
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t2*abb30n13
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t14 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t15 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t16 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t17 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t18 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t19 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t20 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t21 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t22 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t23 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t24 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t25 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d30 = (t1*abb30n10+t1*abb30n67+t10*t9+t2*abb30n11+t2*abb30n50+t2*abb30n9+t&
      &3*abb30n31+t4*abb30n51+t5*t6+t6*t7+t8*t9+t1*t12*abb30n22+t1*t13*abb30n22+&
      &t1*t15*abb30n23+t1*t2*abb30n21+t10*t16*abb30n34+t10*t21*abb30n54+t11*t12*&
      &abb30n15+t11*t13*abb30n15+t11*t16*abb30n35+t11*t2*abb30n14+t11*t21*abb30n&
      &55+t12*t14*abb30n16+t12*t15*abb30n18+t12*t17*abb30n37+t12*t18*abb30n39+t1&
      &2*t19*abb30n40+t12*t20*abb30n42+t12*t22*abb30n57+t12*t23*abb30n58+t12*t24&
      &*abb30n60+t12*t25*abb30n62+t13*t14*abb30n16+t13*t15*abb30n18+t13*t17*abb3&
      &0n37+t13*t18*abb30n39+t13*t19*abb30n40+t13*t20*abb30n42+t13*t22*abb30n57+&
      &t13*t23*abb30n58+t13*t24*abb30n60+t13*t25*abb30n62+t14*t16*abb30n36+t14*t&
      &2*abb30n17+t14*t21*abb30n56+t15*t17*abb30n43+t15*t18*abb30n44+t15*t19*abb&
      &30n45+t15*t2*abb30n19+t15*t20*abb30n46+t15*t22*abb30n63+t15*t23*abb30n64+&
      &t15*t24*abb30n65+t15*t25*abb30n66+t15*t3*abb30n20+t15*t4*abb30n20+t16*t5*&
      &abb30n33+t16*t7*abb30n33+t16*t8*abb30n34+t18*t2*abb30n38+t2*t20*abb30n41+&
      &t2*t23*abb30n59+t2*t25*abb30n61+t2*abb30n28*(Q(1)*spvak3k5(1)-Q(2)*spvak3&
      &k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t2*abb30n29*(Q(1)*spvak3k6(1)-Q(&
      &2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t2*abb30n30*(Q(1)*spvak&
      &3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4))+t2*abb30n32*(Q&
      &(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t2*ab&
      &b30n47*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(&
      &4))+t2*abb30n48*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*&
      &spvak6k4(4))+t2*abb30n49*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4&
      &(3)-Q(4)*spvak7k4(4))+t2*abb30n52*(Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)&
      &*spvak8k4(3)-Q(4)*spvak8k4(4))+t21*t5*abb30n53+t21*t7*abb30n53+t21*t8*abb&
      &30n54+t1*t10*t15*abb30n24+t1*t11*t15*abb30n26+t1*t14*t15*abb30n27+t1*t15*&
      &t5*abb30n25+t1*t15*t7*abb30n25+t1*t15*t8*abb30n24)
      numerator = cmplx(real(d30, ki), aimag(d30), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P2B_ddx_ssx_globalsl1, only: epspow
      use P2B_ddx_ssx_kinematics
      use P2B_ddx_ssx_abbrevd30h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d30
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d30 = 0.0_ki
      t1 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = t2*abb30n12
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t2*abb30n13
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t14 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t15 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t16 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t17 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t18 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t19 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t20 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t21 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t22 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t23 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t24 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t25 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d30 = (t1*abb30n10+t1*abb30n67+t10*t9+t2*abb30n11+t2*abb30n50+t2*abb30n9+t&
      &3*abb30n31+t4*abb30n51+t5*t6+t6*t7+t8*t9+t1*t12*abb30n22+t1*t13*abb30n22+&
      &t1*t15*abb30n23+t1*t2*abb30n21+t10*t16*abb30n34+t10*t21*abb30n54+t11*t12*&
      &abb30n15+t11*t13*abb30n15+t11*t16*abb30n35+t11*t2*abb30n14+t11*t21*abb30n&
      &55+t12*t14*abb30n16+t12*t15*abb30n18+t12*t17*abb30n37+t12*t18*abb30n39+t1&
      &2*t19*abb30n40+t12*t20*abb30n42+t12*t22*abb30n57+t12*t23*abb30n58+t12*t24&
      &*abb30n60+t12*t25*abb30n62+t13*t14*abb30n16+t13*t15*abb30n18+t13*t17*abb3&
      &0n37+t13*t18*abb30n39+t13*t19*abb30n40+t13*t20*abb30n42+t13*t22*abb30n57+&
      &t13*t23*abb30n58+t13*t24*abb30n60+t13*t25*abb30n62+t14*t16*abb30n36+t14*t&
      &2*abb30n17+t14*t21*abb30n56+t15*t17*abb30n43+t15*t18*abb30n44+t15*t19*abb&
      &30n45+t15*t2*abb30n19+t15*t20*abb30n46+t15*t22*abb30n63+t15*t23*abb30n64+&
      &t15*t24*abb30n65+t15*t25*abb30n66+t15*t3*abb30n20+t15*t4*abb30n20+t16*t5*&
      &abb30n33+t16*t7*abb30n33+t16*t8*abb30n34+t18*t2*abb30n38+t2*t20*abb30n41+&
      &t2*t23*abb30n59+t2*t25*abb30n61+t2*abb30n28*(Q(1)*spvak3k5(1)-Q(2)*spvak3&
      &k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t2*abb30n29*(Q(1)*spvak3k6(1)-Q(&
      &2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t2*abb30n30*(Q(1)*spvak&
      &3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4))+t2*abb30n32*(Q&
      &(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t2*ab&
      &b30n47*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(&
      &4))+t2*abb30n48*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*&
      &spvak6k4(4))+t2*abb30n49*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4&
      &(3)-Q(4)*spvak7k4(4))+t2*abb30n52*(Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)&
      &*spvak8k4(3)-Q(4)*spvak8k4(4))+t21*t5*abb30n53+t21*t7*abb30n53+t21*t8*abb&
      &30n54+t1*t10*t15*abb30n24+t1*t11*t15*abb30n26+t1*t14*t15*abb30n27+t1*t15*&
      &t5*abb30n25+t1*t15*t7*abb30n25+t1*t15*t8*abb30n24)

      numerator = cmplx(real(d30, ki), aimag(d30), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P2B_ddx_ssx_d30h3l1
