* vim: ts=3:sw=3
#define LEGS "8"
* Flag: Rewrite gauge boson legs as eps(k) -> eps(k) + gaugeXz * k
#define GAUGEVAR "1"
*---#[ symbol definitions :
Symbols spak1k2,spbk2k1,spak1k3,spbk3k1,spak1k4,spbk4k1,spak1k5;
Symbols spbk5k1,spak1k6,spbk6k1,spak1k7,spbk7k1,spak1k8,spbk8k1;
Symbols spak2k3,spbk3k2,spak2k4,spbk4k2,spak2k5,spbk5k2,spak2k6;
Symbols spbk6k2,spak2k7,spbk7k2,spak2k8,spbk8k2,spak3k4,spbk4k3;
Symbols spak3k5,spbk5k3,spak3k6,spbk6k3,spak3k7,spbk7k3,spak3k8;
Symbols spbk8k3,spak4k5,spbk5k4,spak4k6,spbk6k4,spak4k7,spbk7k4;
Symbols spak4k8,spbk8k4,spak5k6,spbk6k5,spak5k7,spbk7k5,spak5k8;
Symbols spbk8k5,spak6k7,spbk7k6,spak6k8,spbk8k6,spak7k8,spbk8k7;
Symbols es1, es12, es2, es123, es23, es3, es1234, es234, es34, es4;
Symbols es678, es2345, es345, es45, es5, es78, es781, es3456, es456, es56, es6, es8, es81, es812, es4567, es567, es67, es7;
Symbols es6, es8, es81, es812, es4567, es567, es67, es7;
Vectors k1, ..., k`LEGS';
#If `LOOPS' == 1
	Vector p1;
	Vectors r1, ..., r`LEGS';
#EndIf

Indices i1C3, i1L1, i2C3, i2L1, o1C3, o1L1, o2C3, o2L1, o3C1, o3L1;
Indices o4C1, o4L1, o5C1, o5L1, o6C1, o6L1;
*---#] symbol definitions :
*---#[ set of kinematic invariants :
#Define KinInvariants "spak1k2,spbk2k1,spak1k3,spbk3k1,spak1k4,spbk4k1,spak1k5,\
   spbk5k1,spak1k6,spbk6k1,spak1k7,spbk7k1,spak1k8,spbk8k1,\
   spak2k3,spbk3k2,spak2k4,spbk4k2,spak2k5,spbk5k2,spak2k6,\
   spbk6k2,spak2k7,spbk7k2,spak2k8,spbk8k2,spak3k4,spbk4k3,\
   spak3k5,spbk5k3,spak3k6,spbk6k3,spak3k7,spbk7k3,spak3k8,\
   spbk8k3,spak4k5,spbk5k4,spak4k6,spbk6k4,spak4k7,spbk7k4,\
   spak4k8,spbk8k4,spak5k6,spbk6k5,spak5k7,spbk7k5,spak5k8,\
   spbk8k5,spak6k7,spbk7k6,spak6k8,spbk8k6,spak7k8,spbk8k7"
*---#] set of kinematic invariants :
*---#[ procedure zeroes :
#procedure zeroes
	Multiply replace_(me, 0, mD, 0, mC, 0, mB, 0, mmu, 0, mU, 0, wT, 0, mS, 0);
#endprocedure
*---#] procedure zeroes :
*---#[ procedure ones :
#procedure ones
	Multiply replace_(e, 1, gs, 1);
#endprocedure
*---#] procedure ones :
*---#[ procedure conservation :
#procedure conservation
	Id k8 = +k1+k2-k3-k4-k5-k6-k7;
#endprocedure
*---#] procedure conservation :
*---#[ procedure kinematics :
#procedure kinematics
	Id k1.k1 = 0;
	Id k1.k2 = 1/2 * (es12);
	Id k1.k3 = 1/2 * (-es123+es23+es12);
	Id k1.k4 = 1/2 * (es123+es234-es23-es1234);
	Id k1.k5 = 1/2 * (-es234+es2345+es1234-es678);
	Id k1.k6 = 1/2 * (es678-es78-es2345+es781);
	Id k1.k7 = 1/2 * (es81-es781+es78);
	Id k1.k8 = 1/2 * (-es81);
	Id k2.k2 = 0;
	Id k2.k3 = 1/2 * (-es23);
	Id k2.k4 = 1/2 * (-es234+es23+es34);
	Id k2.k5 = 1/2 * (es234+es345-es34-es2345);
	Id k2.k6 = 1/2 * (es3456-es345+es2345-es781);
	Id k2.k7 = 1/2 * (es812-es81-es3456+es781);
	Id k2.k8 = 1/2 * (-es812+es81+es12);
	Id k3.k3 = 0;
	Id k3.k4 = 1/2 * (es34);
	Id k3.k5 = 1/2 * (-es45+es345-es34);
	Id k3.k6 = 1/2 * (es45+es3456-es345-es456);
	Id k3.k7 = 1/2 * (es812-es3456+es456-es4567);
	Id k3.k8 = 1/2 * (-es812+es12+es4567-es123);
	Id k4.k4 = 0;
	Id k4.k5 = 1/2 * (es45);
	Id k4.k6 = 1/2 * (-es45+es456-es56);
	Id k4.k7 = 1/2 * (es56+es4567-es456-es567);
	Id k4.k8 = 1/2 * (es123-es4567+es567-es1234);
	Id k5.k5 = 0;
	Id k5.k6 = 1/2 * (es56);
	Id k5.k7 = 1/2 * (-es67+es567-es56);
	Id k5.k8 = 1/2 * (-es678+es67+es1234-es567);
	Id k6.k6 = 0;
	Id k6.k7 = 1/2 * (es67);
	Id k6.k8 = 1/2 * (-es67+es678-es78);
	Id k7.k7 = 0;
	Id k7.k8 = 1/2 * (es78);
	Id k8.k8 = 0;
#endprocedure
*---#] procedure kinematics :
*---#[ procedure spsymbols :
#procedure spsymbols
Id Spa2(k1, k2) = spak1k2;
Id Spb2(k2, k1) = spbk2k1;
Id Spa2(k1, k3) = spak1k3;
Id Spb2(k3, k1) = spbk3k1;
Id Spa2(k1, k4) = spak1k4;
Id Spb2(k4, k1) = spbk4k1;
Id Spa2(k1, k5) = spak1k5;
Id Spb2(k5, k1) = spbk5k1;
Id Spa2(k1, k6) = spak1k6;
Id Spb2(k6, k1) = spbk6k1;
Id Spa2(k1, k7) = spak1k7;
Id Spb2(k7, k1) = spbk7k1;
Id Spa2(k1, k8) = spak1k8;
Id Spb2(k8, k1) = spbk8k1;
Id Spa2(k2, k3) = spak2k3;
Id Spb2(k3, k2) = spbk3k2;
Id Spa2(k2, k4) = spak2k4;
Id Spb2(k4, k2) = spbk4k2;
Id Spa2(k2, k5) = spak2k5;
Id Spb2(k5, k2) = spbk5k2;
Id Spa2(k2, k6) = spak2k6;
Id Spb2(k6, k2) = spbk6k2;
Id Spa2(k2, k7) = spak2k7;
Id Spb2(k7, k2) = spbk7k2;
Id Spa2(k2, k8) = spak2k8;
Id Spb2(k8, k2) = spbk8k2;
Id Spa2(k3, k4) = spak3k4;
Id Spb2(k4, k3) = spbk4k3;
Id Spa2(k3, k5) = spak3k5;
Id Spb2(k5, k3) = spbk5k3;
Id Spa2(k3, k6) = spak3k6;
Id Spb2(k6, k3) = spbk6k3;
Id Spa2(k3, k7) = spak3k7;
Id Spb2(k7, k3) = spbk7k3;
Id Spa2(k3, k8) = spak3k8;
Id Spb2(k8, k3) = spbk8k3;
Id Spa2(k4, k5) = spak4k5;
Id Spb2(k5, k4) = spbk5k4;
Id Spa2(k4, k6) = spak4k6;
Id Spb2(k6, k4) = spbk6k4;
Id Spa2(k4, k7) = spak4k7;
Id Spb2(k7, k4) = spbk7k4;
Id Spa2(k4, k8) = spak4k8;
Id Spb2(k8, k4) = spbk8k4;
Id Spa2(k5, k6) = spak5k6;
Id Spb2(k6, k5) = spbk6k5;
Id Spa2(k5, k7) = spak5k7;
Id Spb2(k7, k5) = spbk7k5;
Id Spa2(k5, k8) = spak5k8;
Id Spb2(k8, k5) = spbk8k5;
Id Spa2(k6, k7) = spak6k7;
Id Spb2(k7, k6) = spbk7k6;
Id Spa2(k6, k8) = spak6k8;
Id Spb2(k8, k6) = spbk8k6;
Id Spa2(k7, k8) = spak7k8;
Id Spb2(k8, k7) = spbk8k7;
#endprocedure
*---#] procedure spsymbols :
*---#[ procedure rewritelegs :
#procedure rewritelegs
	Id inp(field1?, k1) = inp(field1, k1, `HELi1');
	Id inp(field1?, k2) = inp(field1, k2, `HELi2');
	Id out(field1?, k3) = out(field1, k3, `HELo1');
	Id out(field1?, k4) = out(field1, k4, `HELo2');
	Id out(field1?, k5) = out(field1, k5, `HELo3');
	Id out(field1?, k6) = out(field1, k6, `HELo4');
	Id out(field1?, k7) = out(field1, k7, `HELo5');
	Id out(field1?, k8) = out(field1, k8, `HELo6');
#endprocedure
*---#] procedure rewritelegs :
#define LIGHTLIKE "k1,k2,k3,k4,k5,k6,k7,k8"
#define EXTERNAL "k1,k2,k3,k4,k5,k6,k7,k8"
*---#[ color :
*---#[ procedure colorbasis :
#procedure colorbasis
	Id inpcolor(1, idxi1C3?)*
		inpcolor(2, idxi1C3?)*
		outcolor(1, idxo2C3?)*
		outcolor(2, idxo2C3?)*
		outcolor(3, idxo3C1?)*
		outcolor(4, idxo4C1?)*
		outcolor(5, idxo5C1?)*
		outcolor(6, idxo6C1?) = c1;
	Id inpcolor(1, idxi1C3?)*
		inpcolor(2, idxo2C3?)*
		outcolor(1, idxi1C3?)*
		outcolor(2, idxo2C3?)*
		outcolor(3, idxo3C1?)*
		outcolor(4, idxo4C1?)*
		outcolor(5, idxo5C1?)*
		outcolor(6, idxo6C1?) = c2;
#endprocedure

*---#] procedure colorbasis :
Symbols c1, ..., c2;
#define NUMCS "2"
#define INCOLORS "NC,NC"
#define COLORED "1,2,3,4"
*---#[ procedure invcolorbasis :
#procedure invcolorbasis(suffix,num)
	#if `num' == 1
		Id c(1, m?) = c(1, m) * (
			inpcolor(1, idxi1C3`suffix', `num')*
			inpcolor(2, idxi2C3`suffix', `num')*
			outcolor(1, idxo1C3`suffix', `num')*
			outcolor(2, idxo2C3`suffix', `num')*
			outcolor(3, idxo3C1`suffix', `num')*
			outcolor(4, idxo4C1`suffix', `num')*
			outcolor(5, idxo5C1`suffix', `num')*
			outcolor(6, idxo6C1`suffix', `num')*
			d_(idxi2C3`suffix', idxi1C3`suffix')*
			d_(idxo1C3`suffix', idxo2C3`suffix'));
	#else
		Id c(m?, 1) = c(m, 1) * (
			inpcolor(1, idxi1C3`suffix', `num')*
			inpcolor(2, idxi2C3`suffix', `num')*
			outcolor(1, idxo1C3`suffix', `num')*
			outcolor(2, idxo2C3`suffix', `num')*
			outcolor(3, idxo3C1`suffix', `num')*
			outcolor(4, idxo4C1`suffix', `num')*
			outcolor(5, idxo5C1`suffix', `num')*
			outcolor(6, idxo6C1`suffix', `num')*
			d_(idxi2C3`suffix', idxi1C3`suffix')*
			d_(idxo1C3`suffix', idxo2C3`suffix'));
	#endif
	#if `num' == 1
		Id c(2, m?) = c(2, m) * (
			inpcolor(1, idxi1C3`suffix', `num')*
			inpcolor(2, idxi2C3`suffix', `num')*
			outcolor(1, idxo1C3`suffix', `num')*
			outcolor(2, idxo2C3`suffix', `num')*
			outcolor(3, idxo3C1`suffix', `num')*
			outcolor(4, idxo4C1`suffix', `num')*
			outcolor(5, idxo5C1`suffix', `num')*
			outcolor(6, idxo6C1`suffix', `num')*
			d_(idxi2C3`suffix', idxo2C3`suffix')*
			d_(idxo1C3`suffix', idxi1C3`suffix'));
	#else
		Id c(m?, 2) = c(m, 2) * (
			inpcolor(1, idxi1C3`suffix', `num')*
			inpcolor(2, idxi2C3`suffix', `num')*
			outcolor(1, idxo1C3`suffix', `num')*
			outcolor(2, idxo2C3`suffix', `num')*
			outcolor(3, idxo3C1`suffix', `num')*
			outcolor(4, idxo4C1`suffix', `num')*
			outcolor(5, idxo5C1`suffix', `num')*
			outcolor(6, idxo6C1`suffix', `num')*
			d_(idxi2C3`suffix', idxo2C3`suffix')*
			d_(idxo1C3`suffix', idxi1C3`suffix'));
	#endif
#endprocedure
*---#] procedure invcolorbasis :
*---#[ procedure colorinsertion :
#procedure colorinsertion
	Id propcolor(1, 1) * inpcolor(1, idxi1C3a?, 1) * inpcolor(1, idxi1C3b?, 2) =
		TR*(NC - 1/NC) * delta(idxi1C3a, idxi1C3b);
	Id propcolor(1, m?) * inpcolor(1, idxi1C3a?, 1) * inpcolor(1, idxi1C3b?, 2) =
		propcolor(1, m)*T(idxIns, idxi1C3a, idxi1C3b);
	Id propcolor(m?, 1) * inpcolor(1, idxi1C3a?, 1) * inpcolor(1, idxi1C3b?, 2) =
		propcolor(m, 1)*T(idxIns, idxi1C3a, idxi1C3b);
	Id inpcolor(1, idxi1C3a?, 1) * inpcolor(1, idxi1C3b?, 2) =
		delta(idxi1C3a, idxi1C3b);
	Id propcolor(2, 2) * inpcolor(2, idxi2C3a?, 1) * inpcolor(2, idxi2C3b?, 2) =
		TR*(NC - 1/NC) * delta(idxi2C3a, idxi2C3b);
	Id propcolor(2, m?) * inpcolor(2, idxi2C3a?, 1) * inpcolor(2, idxi2C3b?, 2) =
		propcolor(2, m)*(-1)*T(idxIns, idxi2C3b, idxi2C3a);
	Id propcolor(m?, 2) * inpcolor(2, idxi2C3a?, 1) * inpcolor(2, idxi2C3b?, 2) =
		propcolor(m, 2)*(-1)*T(idxIns, idxi2C3b, idxi2C3a);
	Id inpcolor(2, idxi2C3a?, 1) * inpcolor(2, idxi2C3b?, 2) =
		delta(idxi2C3a, idxi2C3b);
	Id propcolor(3, 3) * outcolor(1, idxo1C3a?, 1) * outcolor(1, idxo1C3b?, 2) =
		TR*(NC - 1/NC) * delta(idxo1C3a, idxo1C3b);
	Id propcolor(3, m?) * outcolor(1, idxo1C3a?, 1) * outcolor(1, idxo1C3b?, 2) =
		propcolor(3, m)*(-1)*T(idxIns, idxo1C3b, idxo1C3a);
	Id propcolor(m?, 3) * outcolor(1, idxo1C3a?, 1) * outcolor(1, idxo1C3b?, 2) =
		propcolor(m, 3)*(-1)*T(idxIns, idxo1C3b, idxo1C3a);
	Id outcolor(1, idxo1C3a?, 1) * outcolor(1, idxo1C3b?, 2) =
		delta(idxo1C3a, idxo1C3b);
	Id propcolor(4, 4) * outcolor(2, idxo2C3a?, 1) * outcolor(2, idxo2C3b?, 2) =
		TR*(NC - 1/NC) * delta(idxo2C3a, idxo2C3b);
	Id propcolor(4, m?) * outcolor(2, idxo2C3a?, 1) * outcolor(2, idxo2C3b?, 2) =
		propcolor(4, m)*T(idxIns, idxo2C3a, idxo2C3b);
	Id propcolor(m?, 4) * outcolor(2, idxo2C3a?, 1) * outcolor(2, idxo2C3b?, 2) =
		propcolor(m, 4)*T(idxIns, idxo2C3a, idxo2C3b);
	Id outcolor(2, idxo2C3a?, 1) * outcolor(2, idxo2C3b?, 2) =
		delta(idxo2C3a, idxo2C3b);
	Id propcolor(5, 5) * outcolor(3, idxo3C1a?, 1) * outcolor(3, idxo3C1b?, 2) =
		1;
	Id propcolor(5, m?) * outcolor(3, idxo3C1a?, 1) * outcolor(3, idxo3C1b?, 2) =
		propcolor(5, m)*0;
	Id propcolor(m?, 5) * outcolor(3, idxo3C1a?, 1) * outcolor(3, idxo3C1b?, 2) =
		propcolor(m, 5)*0;
	Id outcolor(3, idxo3C1a?, 1) * outcolor(3, idxo3C1b?, 2) =
		1;
	Id propcolor(6, 6) * outcolor(4, idxo4C1a?, 1) * outcolor(4, idxo4C1b?, 2) =
		1;
	Id propcolor(6, m?) * outcolor(4, idxo4C1a?, 1) * outcolor(4, idxo4C1b?, 2) =
		propcolor(6, m)*0;
	Id propcolor(m?, 6) * outcolor(4, idxo4C1a?, 1) * outcolor(4, idxo4C1b?, 2) =
		propcolor(m, 6)*0;
	Id outcolor(4, idxo4C1a?, 1) * outcolor(4, idxo4C1b?, 2) =
		1;
	Id propcolor(7, 7) * outcolor(5, idxo5C1a?, 1) * outcolor(5, idxo5C1b?, 2) =
		1;
	Id propcolor(7, m?) * outcolor(5, idxo5C1a?, 1) * outcolor(5, idxo5C1b?, 2) =
		propcolor(7, m)*0;
	Id propcolor(m?, 7) * outcolor(5, idxo5C1a?, 1) * outcolor(5, idxo5C1b?, 2) =
		propcolor(m, 7)*0;
	Id outcolor(5, idxo5C1a?, 1) * outcolor(5, idxo5C1b?, 2) =
		1;
	Id propcolor(8, 8) * outcolor(6, idxo6C1a?, 1) * outcolor(6, idxo6C1b?, 2) =
		1;
	Id propcolor(8, m?) * outcolor(6, idxo6C1a?, 1) * outcolor(6, idxo6C1b?, 2) =
		propcolor(8, m)*0;
	Id propcolor(m?, 8) * outcolor(6, idxo6C1a?, 1) * outcolor(6, idxo6C1b?, 2) =
		propcolor(m, 8)*0;
	Id outcolor(6, idxo6C1a?, 1) * outcolor(6, idxo6C1b?, 2) =
		1;
#endprocedure
*---#] procedure colorinsertion :
*---#] color :
