# vim: ts=3:sw=3:expandtab:syntax=python
#
# This file has been generated automatically.

from golem.topolopy.objects import Diagram, Leg, Propagator, Vertex

generation_info = {
    'program': "qgraf-3.1.2",
    'model': "Standard Model",
    'qgraf.dat': [
       """output = 'topovirt.py';""",
       """style = 'topolopy.sty';""",
       """model = 'model';""",
       """in = D[k1], Dbar[k2];""",
       """out = S[k3], Sbar[k4], ne[k5], ep[k6], mum[k7], nmubar[k8];""",
       """loops=1;""",
       """loop_momentum=p;""",
       """options=onshell, notadpole, nosnail;""",
       """true=iprop[chi,phim,phip,H,0,0];""",
       """true=bridge[Wp,Wm,2,200];""",
       """true=bridge[ep,em,mum,mup,ne,nmu,nebar,nmubar,0,0];""",
       """true=chord[T,B,0,0];""",
       """true=vsum[QCD,4,4];"""]
}

diagrams = {}

#---#[ diagrams[1]:
diagrams[1] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1+k2-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[1]:
#---#[ diagrams[2]:
diagrams[2] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[2]:
#---#[ diagrams[3]:
diagrams[3] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "C", 6, 1, 5, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 5, 1, 7, 2, "-p1+k1+k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "-p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "-p1+k1+k2-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[3]:
#---#[ diagrams[4]:
diagrams[4] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "S", 5, 1, 6, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1-k3-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "p1-k1-k2+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[4]:
#---#[ diagrams[5]:
diagrams[5] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[5]:
#---#[ diagrams[6]:
diagrams[6] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[6]:
#---#[ diagrams[7]:
diagrams[7] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "C", 5, 1, 6, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 7, 1, 5, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1-k3-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "C", "Wm"))
#---#] diagrams[7]:
#---#[ diagrams[8]:
diagrams[8] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "-p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "C", "Wm"))
#---#] diagrams[8]:
#---#[ diagrams[9]:
diagrams[9] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[9]:
#---#[ diagrams[10]:
diagrams[10] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[10]:
#---#[ diagrams[11]:
diagrams[11] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "C", 5, 1, 6, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 7, 1, 5, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[11]:
#---#[ diagrams[12]:
diagrams[12] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "-p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[12]:
#---#[ diagrams[13]:
diagrams[13] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[13]:
#---#[ diagrams[14]:
diagrams[14] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[14]:
#---#[ diagrams[15]:
diagrams[15] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[15]:
#---#[ diagrams[16]:
diagrams[16] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[16]:
#---#[ diagrams[17]:
diagrams[17] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[17]:
#---#[ diagrams[18]:
diagrams[18] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[18]:
#---#[ diagrams[19]:
diagrams[19] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[19]:
#---#[ diagrams[20]:
diagrams[20] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[20]:
#---#[ diagrams[21]:
diagrams[21] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "-p1+k1+k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[21]:
#---#[ diagrams[22]:
diagrams[22] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "C", 6, 1, 7, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k3-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[22]:
#---#[ diagrams[23]:
diagrams[23] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 7, 1, 6, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[23]:
#---#[ diagrams[24]:
diagrams[24] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1-k3-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[24]:
#---#[ diagrams[25]:
diagrams[25] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[25]:
#---#[ diagrams[26]:
diagrams[26] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[26]:
#---#[ diagrams[27]:
diagrams[27] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[27]:
#---#[ diagrams[28]:
diagrams[28] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[28]:
#---#[ diagrams[29]:
diagrams[29] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "-p1+k1+k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[29]:
#---#[ diagrams[30]:
diagrams[30] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "C", 6, 1, 7, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k3-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[30]:
#---#[ diagrams[31]:
diagrams[31] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 7, 1, 6, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[31]:
#---#[ diagrams[32]:
diagrams[32] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1-k3-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[32]:
#---#[ diagrams[33]:
diagrams[33] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[33]:
#---#[ diagrams[34]:
diagrams[34] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[34]:
#---#[ diagrams[35]:
diagrams[35] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[35]:
#---#[ diagrams[36]:
diagrams[36] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[36]:
#---#[ diagrams[37]:
diagrams[37] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[37]:
#---#[ diagrams[38]:
diagrams[38] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[38]:
#---#[ diagrams[39]:
diagrams[39] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[39]:
#---#[ diagrams[40]:
diagrams[40] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[40]:
#---#[ diagrams[41]:
diagrams[41] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 6, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 7, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 6, 3, 5, 3, "p1+k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 5, 1, 8, 2, "p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[41]:
#---#[ diagrams[42]:
diagrams[42] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 1, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 6, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 7, 1, 4, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 6, 3, 5, 3, "p1-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 5, 1, 8, 2, "p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[42]:
#---#[ diagrams[43]:
diagrams[43] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 4, 1, 6, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "-p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[43]:
#---#[ diagrams[44]:
diagrams[44] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "C", "Wm"))
#---#] diagrams[44]:
#---#[ diagrams[45]:
diagrams[45] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 6, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[45]:
#---#[ diagrams[46]:
diagrams[46] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 6, 1, 4, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[46]:
#---#[ diagrams[47]:
diagrams[47] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 8, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[47]:
#---#[ diagrams[48]:
diagrams[48] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 8, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 6, 1, 4, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[48]:
#---#[ diagrams[49]:
diagrams[49] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 5, 1, 8, 2, "p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[49]:
#---#[ diagrams[50]:
diagrams[50] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 5, 1, 8, 2, "p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[50]:
#---#[ diagrams[51]:
diagrams[51] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 5, 2, "-p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[51]:
#---#[ diagrams[52]:
diagrams[52] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 5, 2, "-p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[52]:
#---#[ diagrams[53]:
diagrams[53] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "S", 7, 1, 8, 2, "p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[53]:
#---#[ diagrams[54]:
diagrams[54] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 5, 1, 8, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[54]:
#---#[ diagrams[55]:
diagrams[55] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "S", 7, 1, 8, 2, "p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[55]:
#---#[ diagrams[56]:
diagrams[56] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 5, 1, 8, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[56]:
#---#[ diagrams[57]:
diagrams[57] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "S", 4, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[57]:
#---#[ diagrams[58]:
diagrams[58] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "S", 4, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[58]:
#---#[ diagrams[59]:
diagrams[59] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "S", 4, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[59]:
#---#[ diagrams[60]:
diagrams[60] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "S", 4, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[60]:
#---#[ diagrams[61]:
diagrams[61] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[61]:
#---#[ diagrams[62]:
diagrams[62] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 5, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[62]:
#---#[ diagrams[63]:
diagrams[63] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[63]:
#---#[ diagrams[64]:
diagrams[64] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 5, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[64]:
#---#[ diagrams[65]:
diagrams[65] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "D", 8, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[65]:
#---#[ diagrams[66]:
diagrams[66] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "D", 8, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[66]:
#---#[ diagrams[67]:
diagrams[67] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "D", 8, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[67]:
#---#[ diagrams[68]:
diagrams[68] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "D", 8, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[68]:
#---#[ diagrams[69]:
diagrams[69] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 7, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[69]:
#---#[ diagrams[70]:
diagrams[70] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 7, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[70]:
#---#[ diagrams[71]:
diagrams[71] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 4, 1, 7, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 8, 1, 5, 2, "-p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 7, 1, 8, 2, "-p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[71]:
#---#[ diagrams[72]:
diagrams[72] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 4, 1, 7, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 8, 1, 5, 2, "-p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 7, 1, 8, 2, "-p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[72]:
#---#[ diagrams[73]:
diagrams[73] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 7, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[73]:
#---#[ diagrams[74]:
diagrams[74] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 7, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[74]:
#---#[ diagrams[75]:
diagrams[75] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 7, 1, 4, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[75]:
#---#[ diagrams[76]:
diagrams[76] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 7, 1, 4, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[76]:
#---#[ diagrams[77]:
diagrams[77] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[77]:
#---#[ diagrams[78]:
diagrams[78] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[78]:
#---#[ diagrams[79]:
diagrams[79] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[79]:
#---#[ diagrams[80]:
diagrams[80] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[80]:
#---#[ diagrams[81]:
diagrams[81] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[81]:
#---#[ diagrams[82]:
diagrams[82] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[82]:
#---#[ diagrams[83]:
diagrams[83] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[83]:
#---#[ diagrams[84]:
diagrams[84] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[84]:
#---#[ diagrams[85]:
diagrams[85] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[85]:
#---#[ diagrams[86]:
diagrams[86] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[86]:
#---#[ diagrams[87]:
diagrams[87] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[87]:
#---#[ diagrams[88]:
diagrams[88] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[88]:
#---#[ diagrams[89]:
diagrams[89] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[89]:
#---#[ diagrams[90]:
diagrams[90] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[90]:
#---#[ diagrams[91]:
diagrams[91] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[91]:
#---#[ diagrams[92]:
diagrams[92] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[92]:
#---#[ diagrams[93]:
diagrams[93] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[93]:
#---#[ diagrams[94]:
diagrams[94] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "A"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[94]:
#---#[ diagrams[95]:
diagrams[95] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[95]:
#---#[ diagrams[96]:
diagrams[96] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[96]:
#---#[ diagrams[97]:
diagrams[97] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[97]:
#---#[ diagrams[98]:
diagrams[98] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[98]:
#---#[ diagrams[99]:
diagrams[99] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[99]:
#---#[ diagrams[100]:
diagrams[100] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "S", "Z"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[100]:
#---#[ diagrams[101]:
diagrams[101] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[101]:
#---#[ diagrams[102]:
diagrams[102] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[102]:
#---#[ diagrams[103]:
diagrams[103] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[103]:
#---#[ diagrams[104]:
diagrams[104] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[104]:
#---#[ diagrams[105]:
diagrams[105] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[105]:
#---#[ diagrams[106]:
diagrams[106] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[106]:
#---#[ diagrams[107]:
diagrams[107] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[107]:
#---#[ diagrams[108]:
diagrams[108] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[108]:
#---#[ diagrams[109]:
diagrams[109] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[109]:
#---#[ diagrams[110]:
diagrams[110] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[110]:
#---#[ diagrams[111]:
diagrams[111] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[111]:
#---#[ diagrams[112]:
diagrams[112] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[112]:
#---#[ diagrams[113]:
diagrams[113] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[113]:
#---#[ diagrams[114]:
diagrams[114] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[114]:
#---#[ diagrams[115]:
diagrams[115] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[115]:
#---#[ diagrams[116]:
diagrams[116] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[116]:
#---#[ diagrams[117]:
diagrams[117] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[117]:
#---#[ diagrams[118]:
diagrams[118] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "A"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[118]:
#---#[ diagrams[119]:
diagrams[119] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[119]:
#---#[ diagrams[120]:
diagrams[120] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[120]:
#---#[ diagrams[121]:
diagrams[121] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[121]:
#---#[ diagrams[122]:
diagrams[122] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[122]:
#---#[ diagrams[123]:
diagrams[123] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[123]:
#---#[ diagrams[124]:
diagrams[124] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "Z"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[124]:
#---#[ diagrams[125]:
diagrams[125] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 8, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 7, 1, 6, 2, "-p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k5+k6+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[125]:
#---#[ diagrams[126]:
diagrams[126] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 8, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 6, 1, 7, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1-k5-k6-k7-k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[126]:
#---#[ diagrams[127]:
diagrams[127] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k5+k6+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[127]:
#---#[ diagrams[128]:
diagrams[128] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6-k7-k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[128]:
#---#[ diagrams[129]:
diagrams[129] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 8, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 6, 1, 7, 2, "p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1+k1+k2-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[129]:
#---#[ diagrams[130]:
diagrams[130] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 8, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[130]:
#---#[ diagrams[131]:
diagrams[131] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 8, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 6, 1, 7, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1+k1+k2-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[131]:
#---#[ diagrams[132]:
diagrams[132] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 8, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[132]:
#---#[ diagrams[133]:
diagrams[133] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 4, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 7, 1, 6, 2, "-p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1-k1-k2+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[133]:
#---#[ diagrams[134]:
diagrams[134] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[134]:
#---#[ diagrams[135]:
diagrams[135] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 7, 1, 6, 2, "-p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1-k1-k2+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[135]:
#---#[ diagrams[136]:
diagrams[136] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[136]:
#---#[ diagrams[137]:
diagrams[137] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 8, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 7, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 7, 1, 8, 2, "-p1-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[137]:
#---#[ diagrams[138]:
diagrams[138] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 8, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 7, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[138]:
#---#[ diagrams[139]:
diagrams[139] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 4, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 7, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 8, 1, 7, 2, "p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[139]:
#---#[ diagrams[140]:
diagrams[140] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 7, 1, 5, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[140]:
#---#[ diagrams[141]:
diagrams[141] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 6, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "S", 5, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[141]:
#---#[ diagrams[142]:
diagrams[142] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "S", 7, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 6, 1, 8, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[142]:
#---#[ diagrams[143]:
diagrams[143] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[143]:
#---#[ diagrams[144]:
diagrams[144] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[144]:
#---#[ diagrams[145]:
diagrams[145] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[145]:
#---#[ diagrams[146]:
diagrams[146] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[146]:
#---#[ diagrams[147]:
diagrams[147] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[147]:
#---#[ diagrams[148]:
diagrams[148] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[148]:
#---#[ diagrams[149]:
diagrams[149] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[149]:
#---#[ diagrams[150]:
diagrams[150] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[150]:
#---#[ diagrams[151]:
diagrams[151] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 7, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 6, 1, 8, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[151]:
#---#[ diagrams[152]:
diagrams[152] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[152]:
#---#[ diagrams[153]:
diagrams[153] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 7, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 6, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[153]:
#---#[ diagrams[154]:
diagrams[154] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[154]:
#---#[ diagrams[155]:
diagrams[155] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[155]:
#---#[ diagrams[156]:
diagrams[156] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 8, 1, 5, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[156]:
#---#[ diagrams[157]:
diagrams[157] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[157]:
#---#[ diagrams[158]:
diagrams[158] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[158]:
#---#[ diagrams[159]:
diagrams[159] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[159]:
#---#[ diagrams[160]:
diagrams[160] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[160]:
#---#[ diagrams[161]:
diagrams[161] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[161]:
#---#[ diagrams[162]:
diagrams[162] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[162]:
#---#[ diagrams[163]:
diagrams[163] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[163]:
#---#[ diagrams[164]:
diagrams[164] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[164]:
#---#[ diagrams[165]:
diagrams[165] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[165]:
#---#[ diagrams[166]:
diagrams[166] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[166]:
#---#[ diagrams[167]:
diagrams[167] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[167]:
#---#[ diagrams[168]:
diagrams[168] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[168]:
#---#[ diagrams[169]:
diagrams[169] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[169]:
#---#[ diagrams[170]:
diagrams[170] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[170]:
#---#[ diagrams[171]:
diagrams[171] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[171]:
#---#[ diagrams[172]:
diagrams[172] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[172]:
#---#[ diagrams[173]:
diagrams[173] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[173]:
#---#[ diagrams[174]:
diagrams[174] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[174]:
#---#[ diagrams[175]:
diagrams[175] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[175]:
#---#[ diagrams[176]:
diagrams[176] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[176]:
#---#[ diagrams[177]:
diagrams[177] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[177]:
#---#[ diagrams[178]:
diagrams[178] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[178]:
#---#[ diagrams[179]:
diagrams[179] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[179]:
#---#[ diagrams[180]:
diagrams[180] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[180]:
#---#[ diagrams[181]:
diagrams[181] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[181]:
#---#[ diagrams[182]:
diagrams[182] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[182]:
#---#[ diagrams[183]:
diagrams[183] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[183]:
#---#[ diagrams[184]:
diagrams[184] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[184]:
#---#[ diagrams[185]:
diagrams[185] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[185]:
#---#[ diagrams[186]:
diagrams[186] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[186]:
#---#[ diagrams[187]:
diagrams[187] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[187]:
#---#[ diagrams[188]:
diagrams[188] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[188]:
#---#[ diagrams[189]:
diagrams[189] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[189]:
#---#[ diagrams[190]:
diagrams[190] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[190]:
#---#[ diagrams[191]:
diagrams[191] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[191]:
#---#[ diagrams[192]:
diagrams[192] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[192]:
#---#[ diagrams[193]:
diagrams[193] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[193]:
#---#[ diagrams[194]:
diagrams[194] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[194]:
#---#[ diagrams[195]:
diagrams[195] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[195]:
#---#[ diagrams[196]:
diagrams[196] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[196]:
#---#[ diagrams[197]:
diagrams[197] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 7, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[197]:
#---#[ diagrams[198]:
diagrams[198] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 7, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[198]:
#---#[ diagrams[199]:
diagrams[199] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 7, 1, 8, 2, "p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[199]:
#---#[ diagrams[200]:
diagrams[200] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 7, 1, 8, 2, "p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[200]:
#---#[ diagrams[201]:
diagrams[201] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 8, 1, 5, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[201]:
#---#[ diagrams[202]:
diagrams[202] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 8, 1, 5, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[202]:
#---#[ diagrams[203]:
diagrams[203] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[203]:
#---#[ diagrams[204]:
diagrams[204] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[204]:
#---#[ diagrams[205]:
diagrams[205] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 7, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[205]:
#---#[ diagrams[206]:
diagrams[206] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 7, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[206]:
#---#[ diagrams[207]:
diagrams[207] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 7, 1, 8, 2, "-p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[207]:
#---#[ diagrams[208]:
diagrams[208] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 7, 1, 8, 2, "-p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[208]:
#---#[ diagrams[209]:
diagrams[209] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 8, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[209]:
#---#[ diagrams[210]:
diagrams[210] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 8, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[210]:
#---#[ diagrams[211]:
diagrams[211] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[211]:
#---#[ diagrams[212]:
diagrams[212] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[212]:
#---#[ diagrams[213]:
diagrams[213] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[213]:
#---#[ diagrams[214]:
diagrams[214] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[214]:
#---#[ diagrams[215]:
diagrams[215] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[215]:
#---#[ diagrams[216]:
diagrams[216] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[216]:
#---#[ diagrams[217]:
diagrams[217] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[217]:
#---#[ diagrams[218]:
diagrams[218] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[218]:
#---#[ diagrams[219]:
diagrams[219] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[219]:
#---#[ diagrams[220]:
diagrams[220] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 5, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[220]:
#---#[ diagrams[221]:
diagrams[221] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[221]:
#---#[ diagrams[222]:
diagrams[222] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[222]:
#---#[ diagrams[223]:
diagrams[223] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[223]:
#---#[ diagrams[224]:
diagrams[224] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[224]:
#---#[ diagrams[225]:
diagrams[225] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[225]:
#---#[ diagrams[226]:
diagrams[226] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[226]:
#---#[ diagrams[227]:
diagrams[227] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[227]:
#---#[ diagrams[228]:
diagrams[228] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 5, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[228]:
#---#[ diagrams[229]:
diagrams[229] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[229]:
#---#[ diagrams[230]:
diagrams[230] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[230]:
#---#[ diagrams[231]:
diagrams[231] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[231]:
#---#[ diagrams[232]:
diagrams[232] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[232]:
#---#[ diagrams[233]:
diagrams[233] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[233]:
#---#[ diagrams[234]:
diagrams[234] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[234]:
#---#[ diagrams[235]:
diagrams[235] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[235]:
#---#[ diagrams[236]:
diagrams[236] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 5, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[236]:
#---#[ diagrams[237]:
diagrams[237] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[237]:
#---#[ diagrams[238]:
diagrams[238] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[238]:
#---#[ diagrams[239]:
diagrams[239] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[239]:
#---#[ diagrams[240]:
diagrams[240] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[240]:
#---#[ diagrams[241]:
diagrams[241] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[241]:
#---#[ diagrams[242]:
diagrams[242] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[242]:
#---#[ diagrams[243]:
diagrams[243] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[243]:
#---#[ diagrams[244]:
diagrams[244] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 5, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[244]:
#---#[ diagrams[245]:
diagrams[245] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "C", 8, 1, 5, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "S", 7, 1, 6, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "-p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "C", "Wm"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[245]:
#---#[ diagrams[246]:
diagrams[246] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 7, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "C", 5, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[246]:
#---#[ diagrams[247]:
diagrams[247] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 8, 1, 5, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[247]:
#---#[ diagrams[248]:
diagrams[248] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[248]:
#---#[ diagrams[249]:
diagrams[249] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 6, 1, 7, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k5+k6", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[249]:
#---#[ diagrams[250]:
diagrams[250] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "g", 7, 3, 6, 2, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[250]:
#---#[ diagrams[251]:
diagrams[251] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k5+k6", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[251]:
#---#[ diagrams[252]:
diagrams[252] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 6, 2, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[252]:
#---#[ diagrams[253]:
diagrams[253] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[253]:
#---#[ diagrams[254]:
diagrams[254] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[254]:
#---#[ diagrams[255]:
diagrams[255] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[255]:
#---#[ diagrams[256]:
diagrams[256] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "S", 8, 1, 6, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[256]:
#---#[ diagrams[257]:
diagrams[257] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "gh", 8, 1, 6, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(7, "gh", 6, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 1, "ghbar", "gh", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[257]:
#---#[ diagrams[258]:
diagrams[258] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 7, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "g", 8, 2, 6, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[258]:
#---#[ diagrams[259]:
diagrams[259] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[259]:
#---#[ diagrams[260]:
diagrams[260] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[260]:
#---#[ diagrams[261]:
diagrams[261] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[261]:
#---#[ diagrams[262]:
diagrams[262] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "S", 8, 1, 6, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[262]:
#---#[ diagrams[263]:
diagrams[263] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "gh", 8, 1, 6, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(7, "gh", 6, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "ghbar", "gh", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[263]:
#---#[ diagrams[264]:
diagrams[264] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 2, 6, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[264]:
#---#[ diagrams[265]:
diagrams[265] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 4, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "C", 7, 1, 5, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 6, 1, 8, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "C", "Wm"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[265]:
#---#[ diagrams[266]:
diagrams[266] = Diagram(
   Leg(1, True, "D", 1, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 1, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "S", 6, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 7, 1, 8, 2, "-p1-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Dbar", "D", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[266]:
#---#[ diagrams[267]:
diagrams[267] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 6, 1, 8, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[267]:
#---#[ diagrams[268]:
diagrams[268] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 1, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 1, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Sbar", "S", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[268]:
#---#[ diagrams[269]:
diagrams[269] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 5, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 8, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 7, 1, 8, 2, "-p1+k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Cbar", "S", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[269]:
#---#[ diagrams[270]:
diagrams[270] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1+k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[270]:
#---#[ diagrams[271]:
diagrams[271] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 6, 1, 4, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 5, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 7, 1, 8, 2, "-p1-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Sbar", "C", "Wm"),
   Vertex(5, 0, "Cbar", "S", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[271]:
#---#[ diagrams[272]:
diagrams[272] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[272]:
#---#[ diagrams[273]:
diagrams[273] = Diagram(
   Leg(1, True, "D", 2, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 2, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "S", 7, 1, 5, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 6, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Dbar", "D", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[273]:
#---#[ diagrams[274]:
diagrams[274] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 2, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 2, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Sbar", "S", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[274]:
#---#[ diagrams[275]:
diagrams[275] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "C", 4, 1, 6, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "C", 7, 1, 5, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 6, 1, 8, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Sbar", "C", "Wm"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[275]:
#---#[ diagrams[276]:
diagrams[276] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 6, 1, 8, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[276]:
#---#[ diagrams[277]:
diagrams[277] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 7, 1, 5, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "p1-k1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[277]:
#---#[ diagrams[278]:
diagrams[278] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 7, 1, 5, 2, "p1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1+k1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "p1-k2+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[278]:
#---#[ diagrams[279]:
diagrams[279] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 7, 1, 5, 2, "p1-k2+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1+k1-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k3+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[279]:
#---#[ diagrams[280]:
diagrams[280] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 3, 1, 4, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 7, 1, 5, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k4+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[280]:
#---#[ diagrams[281]:
diagrams[281] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "A"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[281]:
#---#[ diagrams[282]:
diagrams[282] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 6, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "A"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[282]:
#---#[ diagrams[283]:
diagrams[283] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "Z"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[283]:
#---#[ diagrams[284]:
diagrams[284] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 6, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "Z"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[284]:
#---#[ diagrams[285]:
diagrams[285] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "A"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[285]:
#---#[ diagrams[286]:
diagrams[286] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 6, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "A"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[286]:
#---#[ diagrams[287]:
diagrams[287] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "Z"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[287]:
#---#[ diagrams[288]:
diagrams[288] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 6, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "Z"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[288]:
#---#[ diagrams[289]:
diagrams[289] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "A"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[289]:
#---#[ diagrams[290]:
diagrams[290] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 6, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "A"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[290]:
#---#[ diagrams[291]:
diagrams[291] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "Z"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[291]:
#---#[ diagrams[292]:
diagrams[292] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 6, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "Z"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[292]:
#---#[ diagrams[293]:
diagrams[293] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 3, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "A"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[293]:
#---#[ diagrams[294]:
diagrams[294] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 3, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 6, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "A"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[294]:
#---#[ diagrams[295]:
diagrams[295] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 3, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "Z"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[295]:
#---#[ diagrams[296]:
diagrams[296] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 3, 1, 4, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 6, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "Z"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[296]:
#---#[ diagrams[297]:
diagrams[297] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 6, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[297]:
#---#[ diagrams[298]:
diagrams[298] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 6, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[298]:
#---#[ diagrams[299]:
diagrams[299] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1+k1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 8, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[299]:
#---#[ diagrams[300]:
diagrams[300] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1+k1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 8, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[300]:
#---#[ diagrams[301]:
diagrams[301] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 6, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[301]:
#---#[ diagrams[302]:
diagrams[302] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 6, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[302]:
#---#[ diagrams[303]:
diagrams[303] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "S", 8, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[303]:
#---#[ diagrams[304]:
diagrams[304] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 4, 1, 3, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "S", 8, 1, 6, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[304]:
#---#[ diagrams[305]:
diagrams[305] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 3, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 4, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 8, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[305]:
#---#[ diagrams[306]:
diagrams[306] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 3, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 4, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 8, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[306]:
#---#[ diagrams[307]:
diagrams[307] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 3, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 8, 1, 4, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 6, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[307]:
#---#[ diagrams[308]:
diagrams[308] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 5, 1, 3, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 8, 1, 4, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 6, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[308]:
#---#[ diagrams[309]:
diagrams[309] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 3, 1, 5, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 4, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 8, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[309]:
#---#[ diagrams[310]:
diagrams[310] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 3, 1, 5, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 4, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 8, 1, 6, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[310]:
#---#[ diagrams[311]:
diagrams[311] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 3, 1, 5, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 8, 1, 4, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "D", 6, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[311]:
#---#[ diagrams[312]:
diagrams[312] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "S", 3, 1, 5, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "D", 8, 1, 4, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "D", 6, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[312]:
#---#[ diagrams[313]:
diagrams[313] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[313]:
#---#[ diagrams[314]:
diagrams[314] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[314]:
#---#[ diagrams[315]:
diagrams[315] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1+k1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "-p1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[315]:
#---#[ diagrams[316]:
diagrams[316] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 4, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 5, 1, 8, 2, "-p1+k1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "-p1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "D", "g"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[316]:
#---#[ diagrams[317]:
diagrams[317] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "-p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[317]:
#---#[ diagrams[318]:
diagrams[318] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "-p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[318]:
#---#[ diagrams[319]:
diagrams[319] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 8, 1, 5, 2, "p1-k2+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1+k1-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[319]:
#---#[ diagrams[320]:
diagrams[320] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "S", 4, 1, 3, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 8, 1, 5, 2, "p1-k2+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1+k1-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "S", "g"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[320]:
#---#[ diagrams[321]:
diagrams[321] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 8, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[321]:
#---#[ diagrams[322]:
diagrams[322] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 8, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 4, 1, 6, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[322]:
#---#[ diagrams[323]:
diagrams[323] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 8, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 6, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[323]:
#---#[ diagrams[324]:
diagrams[324] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 8, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 6, 1, 4, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[324]:
#---#[ diagrams[325]:
diagrams[325] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[325]:
#---#[ diagrams[326]:
diagrams[326] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 4, 1, 6, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[326]:
#---#[ diagrams[327]:
diagrams[327] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 3, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 6, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "-p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Cbar", "S", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[327]:
#---#[ diagrams[328]:
diagrams[328] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 3, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 6, 1, 4, 2, "p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "-p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Cbar", "S", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[328]:
#---#[ diagrams[329]:
diagrams[329] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "S", 5, 1, 4, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[329]:
#---#[ diagrams[330]:
diagrams[330] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "D", 6, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[330]:
#---#[ diagrams[331]:
diagrams[331] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "D", 4, 1, 5, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 6, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[331]:
#---#[ diagrams[332]:
diagrams[332] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "S", 6, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[332]:
#---#[ diagrams[333]:
diagrams[333] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "S", 5, 1, 4, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[333]:
#---#[ diagrams[334]:
diagrams[334] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 8, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "D", 7, 1, 6, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[334]:
#---#[ diagrams[335]:
diagrams[335] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 3, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "D", 4, 1, 5, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 7, 1, 6, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Cbar", "S", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[335]:
#---#[ diagrams[336]:
diagrams[336] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 3, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 4, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "S", 7, 1, 6, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Cbar", "S", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[336]:
#---#[ diagrams[337]:
diagrams[337] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 5, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[337]:
#---#[ diagrams[338]:
diagrams[338] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 4, 1, 6, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 5, 1, 8, 2, "p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "k1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[338]:
#---#[ diagrams[339]:
diagrams[339] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "D", 4, 1, 5, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[339]:
#---#[ diagrams[340]:
diagrams[340] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "D", 5, 1, 4, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "k1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[340]:
#---#[ diagrams[341]:
diagrams[341] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 4, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 4, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 8, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[341]:
#---#[ diagrams[342]:
diagrams[342] = Diagram(
   Leg(1, True, "D", 3, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 4, 1, 6, 2, "-p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "D", 8, 1, 5, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Sbar", "S", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[342]:
#---#[ diagrams[343]:
diagrams[343] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 3, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "D", 4, 1, 5, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Cbar", "S", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[343]:
#---#[ diagrams[344]:
diagrams[344] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 4, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 3, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 3, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "D", 5, 1, 4, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "-k1-k2+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Cbar", "S", "Wp"),
   Vertex(4, 0, "Dbar", "D", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[344]:
#---#[ diagrams[345]:
diagrams[345] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "U", 4, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k3+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[345]:
#---#[ diagrams[346]:
diagrams[346] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 6, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 5, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "U", 4, 1, 8, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "S", 5, 1, 6, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k4+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[346]:
#---#[ diagrams[347]:
diagrams[347] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "C", 4, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 8, 1, 7, 2, "p1-k1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[347]:
#---#[ diagrams[348]:
diagrams[348] = Diagram(
   Leg(1, True, "D", 6, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 5, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "C", 4, 1, 8, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "C", 8, 1, 7, 2, "p1-k2+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[348]:
#---#[ diagrams[349]:
diagrams[349] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[349]:
#---#[ diagrams[350]:
diagrams[350] = Diagram(
   Leg(1, True, "D", 4, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 3, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 5, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 6, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 7, 1, 3, 2, "-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 8, 1, 5, 2, "p1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[350]:
#---#[ diagrams[351]:
diagrams[351] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "C", 4, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[351]:
#---#[ diagrams[352]:
diagrams[352] = Diagram(
   Leg(1, True, "D", 5, 2, "k1", "mD", +1, 3, "D" == "Dbar"),
   Leg(2, True, "Dbar", 6, 1, "k2", "mD", -1, 3, "Dbar" == "D"),
   Leg(1, False, "S", 3, 1, "k3", "mS", +1, 3, "S" == "Sbar"),
   Leg(2, False, "Sbar", 4, 2, "k4", "mS", -1, 3, "Sbar" == "S"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "C", 7, 1, 3, 2, "k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(4, "C", 4, 1, 7, 2, "-k4-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(5, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 5, 1, 8, 2, "-p1+k1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "-p1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Sbar", "C", "Wm"),
   Vertex(4, 0, "Cbar", "S", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[352]:
#-------------------------------------------------------------------
